/*	pi1.c

	Compute Pi using purely serial C.

	Compile this program with the usual cc:

	cc pi1.c -o pi1 -O

	Run it as:

	pi1 1000000

	And you should get output like:

	Estimation of pi is 3.141592653590


	July 1996 by H. Dietz
*/


#include <stdlib.h>
#include <stdio.h>


main(int argc,
char **argv)
{
	register double width, sum;
	register int intervals, i;

	/* get the number of intervals */
	intervals = atoi(argv[1]);
	width = 1.0 / intervals;

	/* do the computation */
	sum = 0;
	for (i=0; i<intervals; ++i) {
		register double x = (i + 0.5) * width;
		sum += 4.0 / (1.0 + x * x);
	}
	sum *= width;

	/* have the console print the result */
	printf("Estimation of pi is %14.12lf\n", sum);

	return(0);
}
