##
##	Ohio Trollius
##	Copyright 1995 The Ohio State University
##
##	Function:	- dungeon configuration
##			- SCO version, not officially supported
##			- original port & testing: Peter Eubert
##			  (Peter.Eubert@iwb.mw.tu-muenchen.d400.de)
##

##
## installation directory
##
## HOME can be any pathname.
##
HOME	= /tmp/lam

##
## installation subdirectories
##
## It is not a good idea to mess with these.
##
IDIR	= $(HOME)/h
OLDIR	= $(HOME)/lib
OBDIR	= $(HOME)/bin
TDIR	= $(HOME)/boot

##
## machine architecture targets
##
## These names are arbitrary.  Change them only if you want to compile
## for multiple architectures in the same source directory.
##
OARCH	= obj

##
## target machine
##
## Do not change, just symbolically link a different config file.
##
ARCH	= SCO

##
## library linking options
##
LIBBIND	=
SYSLIBS	= -lmalloc -lsocket -lpt -lx

##
## LAM timeout values
##
## TO_BOOT		- (secs) until a new, remote lamd is considered dead
## TO_DLO_ACK		- (usecs) until a packet is resent
## TO_DLO_IDLE		- (secs) until a heartbeat packet is sent to quiet
##			  nodes fault tolerant mode (lamboot -x)
##
TO_BOOT		= 60
TO_DLO_ACK	= 500000
TO_DLO_IDLE	= 60

##
## counters (in various units)
##
## TO_DLO_ESTIMATE	- # of daemon requests (in lamd) before any pending
##			  timeout period is declared expired (because select(2)
##			  does not always return portion of timeout remaining)
## DOMAXRESEND		- # of packet retransmissions before destination lamd
##			  is considered dead in fault tolerant mode
##
TO_DLO_ESTIMATE	= 30
DOMAXRESEND	= 100

##
## GER protocol
##
## MPI_GER		- per-process-pair minimum envelope slots
##
MPI_GER		= 8

##
## MPI timers for LAM daemon mode - not relevant to C2C mode
##
## MPIL_LPD_BASE	- constant added to the LAM daemon polling delay
##			  equation when multiple processes/node are present
## MPIL_LPD_MAX		- maximum LAM daemon polling delay - limits
##			  extent of exponential back-off algorithm
##
MPIL_LPD_BASE	= 50000
MPIL_LPD_MAX	= 1000000

##
## tools
##
## These may vary with the flavour of UNIX.
##
CC		= cc -D$(ARCH) -DLAI_TCP -Di386
CPP		= /lib/cpp -D$(ARCH)
EX		= ed
INSTALL		= /bin/cp
MKDEP		= $(DEPTH)/Config/mkdep
RANLIB		= touch
RM		= /bin/rm -f
SED		= sed
SHELL		= /bin/sh
RSH		= /usr/ucb/rsh
