/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	GDB
 *
 *	$Log:	kcreate.c,v $
 * Revision 6.0  96/02/29  13:11:19  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  95/11/20  19:15:22  gdburns
 * Remove unreached return.
 * 
 * Revision 5.2  94/08/22  13:36:07  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.1  94/08/18  09:35:56  gdburns
 * overhaul for new kernel
 * 
 * Revision 5.1  94/05/18  10:36:05  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:21:05  gdburns
 * Ohio Release
 * 
 *	Function:	- creates an OTB process
 *			- does not make a Trollius kernel request
 *			- essentially a packaged fork and exec
 *	Accepts:	- child program name
 *			- argv
 *	Returns:	- (to parent) child pid or ERROR
 */

#include <typical.h>

/*
 * external variables
 */
extern int		errno;

/*
 * external functions
 */
extern void		_cipc_cleanup();

int
kcreate(pathname, argv)

char			*pathname;
char			 *argv[];

{
	int		pid;			/* UNIX process ID */

	switch((pid = fork())) {

		case ERROR:			/* bad fork */
		return(LAMERROR);

		case 0:				/* child */
		_cipc_cleanup();
		execvp(pathname, argv);
		exit(errno);
		break;
	}
/*
 * parent
 */
	return(pid);
}
