/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	GDB
 *
 *	$Log:	di_wait.ext.c,v $
 * Revision 6.0  96/02/29  13:29:26  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  13:46:20  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.1  94/08/18  09:55:12  gdburns
 * overhaul for new kernel
 * Use non-Trollius methods for acks.
 * 
 * Revision 5.1  94/05/18  10:41:20  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:26:00  gdburns
 * Ohio Release
 * 
 * Revision 2.2  94/02/16  14:03:10  gdburns
 * pre-release to 2.3
 * 
 *	Function:	- block waiting for network frame message
 *	Accepts:	- socket descriptor
 */

#include <sys/types.h>
#include <sys/time.h>

#ifdef _AIX
#include <sys/select.h>
#endif

#include <terror.h>

/*
 * external functions 
 */
extern void		di_forward();

void
di_wait(sockd)

int			sockd;

{
	fd_set		readmask;		/* select read-mask */
/*
 * Block for datalink input.
 */
	FD_ZERO(&readmask);
	FD_SET(sockd, &readmask);

	if (select(sockd + 1, &readmask, (fd_set *) 0, (fd_set *) 0,
			(struct timeval *) 0) < 0) {
		terror("dli_inet (select)");
		kexit(errno);
	}

	di_forward();
}
