/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	GDB
 *
 *	$Log:	fqwrite.c,v $
 * Revision 6.0  96/02/29  13:31:02  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/01  21:08:33  gdburns
 * Remove cubix support into a separate library.
 * 
 * Revision 5.2  94/08/22  13:47:59  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  10:42:01  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:26:34  gdburns
 * Ohio Release
 * 
 *	Function:	- writes data to an open file descriptor
 *			- length limited to MAXNMSGLEN
 *			- must be aware of Cubix multi mode
 *	Accepts:	- filed request
 */

#include <errno.h>

#include "filed.h"
#include <freq.h>
#include <net.h>
#include <terror.h>
#include <typical.h>

/*
 * external variables
 */
extern char		fbuf[MAXNMSGLEN];
					/* body of filed request */

/*
 * external functions
 */
extern struct fdesc	*fdfind();	/* find a filed descriptor */
extern void		fsendr();	/* general purpose file reply */
extern void		fdactivate();	/* make sure tfd is active */
extern int4		fmywrite();

void
fqwrite(fq)

struct freq		*fq;

{
	struct fdesc	*f;		/* ptr to target descriptor */
	int4		ret;		/* bytes written by mywrite() */
	int		err;		/* errno */

	f = fdfind(fq->fq_tfd);

	if (f == FDNULL) {
		fsendr(fq->fq_src_node, fq->fq_src_event,
				EBADF, (int4) ERROR, INT4_NIL, INT4_NIL);
		return;
	}

	f->f_src_node = fq->fq_src_node;
	f->f_src_event = fq->fq_src_event;
/*
 * Ensure that the file is activated.
 */
	fdactivate(f);
	ret = fmywrite(f->f_fd, fbuf, fq->fq_length);

	if (ret != ERROR) {
		f->f_flow += ret;
		f->f_ptr += ret;
		err = 0;
	}

	else {
		err = errno;
	}

	if (! (f->f_tflags & F1WAY)) {
		fsendr(fq->fq_src_node, fq->fq_src_event,
				err, ret, INT4_NIL, INT4_NIL);
	}
}
