/*
 *	OSU Research Computing					Trillium
 *	Copyright 1991 The Ohio State University
 *	RBD
 *
 *	$Log:	all_squeue.c,v $
 * Revision 6.0  96/02/29  13:46:26  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  13:56:57  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  10:56:01  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:34:54  gdburns
 * Ohio Release
 * 
 * Revision 2.2  92/04/30  14:40:14  trillium
 * Ohio Release
 * 
 * Revision 2.1  91/10/20  21:25:50  raja
 * initial revision
 * 
 *	Function:	- generic queue management code
 *			- fully static version
 *				- aqs_init(): create a queue
 *			- other functions are macro'ed to the dynamic version
 */

#include <memory.h>
#include <portable.h>
#include <typical.h>
#include <terror.h>
#include <all_queue.h>

/*
 * external variables
 */
extern int		errno;


/*
 *	aqs_init
 *
 *	Function:	- create a static queue
 *
 *	Accepts:	- size of queue
 *			- size of queue element
 *			- queue array
 *			- ptr to static queue descriptor
 *
 *	Returns:	- ptr to static queue descriptor or NULL
 */
SQUEUE *
aqs_init(size, elemsize, queue, aqsd)

int4			size;
int4			elemsize;
void			*queue;
SQUEUE			*aqsd;

{
	if ((size <= INT4_NIL) || (elemsize <= INT4_NIL)) {
		errno = EINVAL;
		return((SQUEUE *) 0);
	}
/*
 * Initialize the queue descriptor.
 */
	aqsd->aq_maxnelem = size;
	aqsd->aq_elemsize = elemsize;
	aqsd->aq_nelem = INT4_NIL;
	aqsd->aq_first = INT4_NIL;
	aqsd->aq_last = INT4_NIL;
	aqsd->aq_queue = queue;

	return(aqsd);
}
