/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	getworkdir.c,v $
 * Revision 6.0  96/02/29  13:47:20  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  13:57:01  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.2  94/08/19  15:54:47  raja
 * Add SCO support.
 * 
 * Revision 5.1.1.1  94/08/18  10:52:01  vaigl-j
 * Add HP-UX support.
 * 
 * Revision 5.1  94/05/18  10:56:45  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:34:59  gdburns
 * Ohio Release
 * 
 * Revision 2.2.1.1  94/02/15  17:56:38  raja
 * Use getcwd() in Solaris.
 * 
 * Revision 2.2  93/07/22  13:57:59  raja
 * pre-release to 2.3
 * 
 *	Function:	- get the user's current working directory
 *			- dynamically allocated space
 *			- use old getwd() for efficiency if possible
 *			- hopefully our MAX is bigger than everybody's MAX
 *			  (someday a _real_ standard will emerge!)
 *	Returns:	- working directory or NULL
 */

#include <stdlib.h>

#define PATHSIZE	2048


char *
getworkdir()

{
	char		*cwd;		/* working directory name */
/*
 * Allocate a hopefully large enough buffer;
 */
	if ((cwd = malloc((unsigned) PATHSIZE)) == 0) {
		return((char *) 0);
	}
/*
 * Get the working directory.
 */
#if SUN4_SOL || HPUX || SCO
	if (getcwd(cwd, PATHSIZE)) {
#else
	if (getwd(cwd)) {
#endif
		return(cwd);
	} else {
		free(cwd);
		return((char *) 0);
	}
}
