/*
 *	Ohio Trollius
 *	(public domain software)
 *	K&R
 *
 *	$Log:	itoa.c,v $
 * Revision 6.0  96/02/29  13:47:21  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  13:57:02  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  10:56:47  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:34:59  gdburns
 * Ohio Release
 * 
 * Revision 2.2  93/05/04  16:53:03  gdburns
 * pre-release to 2.3
 * 
 *	Function:	- K&R itoa()
 */

/*
 * local functions
 */
static void		reverse();

void
itoa(n, s)

char			*s;
int			n;

{
	int		i;
	int		sign;

	if ((sign = n) < 0) n = -n;

	i = 0;

	do {
		s[i++] = n % 10 + '0';
	} while ((n /= 10) > 0);

	if (sign < 0) s[i++] = '-';

	s[i] = '\0';
	reverse(s);
}

/*
 *	reverse
 *
 *	Function:	- reverse string in place
 *	Accepts:	- string
 */
static void
reverse(s)

char			s[];

{
	int		c;
	int		i;
	int		j;

	for (i = 0, j = strlen(s) - 1; i < j; i++, j--) {
		c = s[i];
		s[i] = s[j];
		s[j] = c;
	}
}
