/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	GDB
 *
 *	$Log:	kill.c,v $
 * Revision 6.0  96/02/29  13:47:21  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/10  15:38:03  gdburns
 * Add sockname(), a slight variation on the kill filename.
 * 
 * Revision 5.2  94/08/22  13:57:02  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.1  94/08/19  16:11:35  raja
 * Add SCO support.
 * 
 * Revision 5.1  94/05/18  10:56:49  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:35:00  gdburns
 * Ohio Release
 * 
 *	Function:	- kill file useful routines
 */

#include <pwd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>			/* MAXHOSTNAMELEN in Solaris */

#define KILLDIR		"/tmp/lam-"

/*
 * local variables
 */
static char		host[MAXHOSTNAMELEN + 1];

/*
 *	killname
 *
 *	Function:	- forms kill filename
 *			- allocates space
 *	Returns:	- kill filename
 */
char *
killname()

{
	char		*f_kill;	/* kill file */
	char		*user;		/* user name */
	struct passwd	*pwdent;	/* user's passwd file entry */

	if ((pwdent = getpwuid(getuid())) == 0) {
		return(0);
	}

	user = pwdent->pw_name;

	if (gethostname(host, sizeof(host))) {
		return(0);
	}
/*
 * 2 spaces for '@' and '\0', 8 expansion spaces
 */
	f_kill = malloc((unsigned) (strlen(KILLDIR) + strlen(host) +
			strlen(user) + 2 + 8));

	if (!f_kill) {
		return(0);
	}

	strcpy(f_kill, KILLDIR);
	strcat(f_kill, user);
	strcat(f_kill, "@");
	strcat(f_kill, host);

	return(f_kill);
}

/*
 *	sockname
 *
 *	Function:	- forms process socket filename 
 *	Returns:	- socket filename
 */
char *
sockname()

{
	char		*f_sock;	/* socket filename */

	f_sock = killname();
	if (f_sock == 0) return(0);
		
	strcat(f_sock, "-s");
	return(f_sock);
}
