/*
 *	Ohio Trollius
 *	Copyright 1993 The Ohio State University
 *	RBD
 *
 *	$Log:	microsleep.c,v $
 * Revision 6.0  96/02/29  13:47:23  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  13:57:04  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  10:56:54  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:35:02  gdburns
 * Ohio Release
 * 
 * Revision 2.2  93/07/22  14:00:04  raja
 * pre-release to 2.3
 * 
 *	Function:	- higher precision sleep (microseconds)
 *			- uses select() timeout value
 *			- does not restart if interrupted
 */

#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>

#ifdef _AIX
#include <sys/select.h>
#endif

int
microsleep(usec)

unsigned int		usec;

{
	struct timeval	timeout;

	timeout.tv_sec = usec / 1000000;
	timeout.tv_usec = usec % 1000000;

	while ((select(0, (fd_set *) 0, (fd_set *) 0,
			(fd_set *) 0, &timeout) < 0) && (errno == EINTR));

	return(0);
}
