/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD
 *
 *	$Log:	app_schema.h,v $
 * Revision 6.0  96/02/29  13:53:08  gdburns
 * Ohio Release
 * 
 *	Function:	- application schema templates and constants
 */

#ifndef _APPSCHEMA
#define _APPSCHEMA

#include <all_list.h>
#include <mpisys.h>
#include <portable.h>

/*
 * structures
 */
struct apparg {
	int4		apa_refcount;		/* reference count */
	int4		apa_argc;		/* # cmd line args */
	char		**apa_argv;		/* cmd line args */
};

struct appproc {
	int4		app_srcnode;		/* binary source node */
	int4		app_node;		/* target node */
	int4		app_pid;		/* process ID */
	int4		app_idx;		/* process index */
	struct apparg	*app_args;		/* cmd line args */
};

/*
 * prototypes
 */
#ifndef __ARGS
#if defined(__STDC__) || defined(c_plusplus) || defined(__cplusplus)
#define __ARGS(a)	a
#else
#define __ARGS(a)	()
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern LIST		*app_bufparse __ARGS((char *buf, int size, int *pl));
extern LIST		*app_parse __ARGS((const char *file, int *pl));
extern void		app_doom __ARGS((LIST *ap));
extern void		app_free __ARGS((LIST *ap));
extern int		app_getprocs __ARGS((LIST *ap, struct _gps *w));
extern int		app_sendprocs __ARGS((int np, struct _gps *w));
extern int		app_run __ARGS((LIST *ap, int np, int4 rtf, int v,
					int e));
extern int		app_ger __ARGS((LIST *ap, int e));
extern char		*app_locate __ARGS((char *fname));

#ifdef __cplusplus
}
#endif

#endif	/* _APPSCHEMA */
