/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	GDB
 *
 *	$Log:	flatreq.h,v $
 * Revision 6.0  96/02/29  13:53:23  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/10  15:31:03  gdburns
 * Remove address from reply.
 * 
 * Revision 5.2  94/08/22  14:00:31  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:44:22  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:48:50  gdburns
 * Ohio Release
 * 
 *	Function:	- constants and structures associated
 *			  with the flat server
 */

#ifndef _FLATREQ
#define _FLATREQ

#include <net.h>
#include <portable.h>

/*
 * constants
 */
#define FLPATHLEN	32			/* load file path length */
#define FLMAX		256
#define	EMPTY		((char *) 0)

/*
 * request codes
 */
#define FLQLOAD		1
#define FLQGET		2
#define FLQFORGET	3
#define FLQDONE		4
#define FLQCLEAN	5

/*
 * request template
 */
struct flreq {
	int4		flq_src_node;
	int4		flq_src_event;
	int4		flq_req;
	int4		flq_parm1;
#define flq_tag		flq_parm1
#define flq_pid		flq_parm1
	int4		flq_parm2;
#define flq_malength	flq_parm2
#define flq_dseg	flq_parm2
	int4		flq_parm3;
#define flq_ldlength	flq_parm3
};

/*
 * reply template
 */
struct flreply {
	int4		flr_reply;
};

/*
 * flat table entry
 */
struct flregion {
	int4		fl_tag;			/* identifying tag */
	int4		fl_status;		/* status flag */
	int4		fl_src_event;		/* sender's -pid */
	int4		fl_src_node;		/* sender's nodeid */
	int4		fl_byteswritten;	/* how many so far */
	char		*fl_addr;		/* flatted file name */
};

#endif
