C
C	Ohio Trollius
C	Copyright 1995 The Ohio State University
C	RBD
C
C	$Log:	mpif.h,v $
C  Revision 6.0.1.1  96/03/12  12:23:20  nevin
C  Missing declaration of MPI_ERROR
C  
C  Revision 6.0  96/03/03  22:36:23  nevin
C  Ohio Release
C  
C  Revision 5.2.1.3  96/03/03  22:32:17  nevin
C  Add definition of MPI_NULL_COPY_FN and MPI_NULL_DELETE_FN
C  
C  Revision 5.2.1.2  96/02/18  01:24:36  gdburns
C  Upgrade to MPI 1.1.
C  
C  Revision 5.2.1.1  95/05/31  16:36:38  raja
C  Switch to F77 syntax.
C  
C  Revision 5.2  94/08/22  14:00:39  gdburns
C  Ohio Release
C
C  Revision 5.1.1.1  94/06/20  15:34:35  raja
C  Make MPI_BOTTOM a global variable.
C
C  Revision 5.1  94/05/18  12:44:31  gdburns
C  Ohio Release
C
C  Revision 2.3  94/05/18  12:43:22  gdburns
C  new for 5.1
C
C	Function:	- MPI F77 header file
C

C
C misc. constants
C
       integer MPI_SUCCESS, MPI_ANY_SOURCE, MPI_ANY_TAG
       integer MPI_PROC_NULL, MPI_MAX_PROCESSOR_NAME
       integer MPI_MAX_ERROR_STRING, MPI_UNDEFINED
       integer MPI_CART, MPI_GRAPH, MPI_KEYVAL_INVALID
       integer MPI_STATUS_SIZE, MPI_SOURCE, MPI_TAG, MPI_ERROR
       integer MPI_TAG_UB, MPI_HOST, MPI_IO, MPI_WTIME_IS_GLOBAL
       integer MPI_NULL_COPY_FN, MPI_NULL_DELETE_FN
       integer MPI_BSEND_OVERHEAD

       parameter (MPI_SUCCESS=0)
       parameter (MPI_ANY_SOURCE=-1)
       parameter (MPI_ANY_TAG=-1)
       parameter (MPI_PROC_NULL=-2)
       parameter (MPI_MAX_PROCESSOR_NAME=256)
       parameter (MPI_MAX_ERROR_STRING=80)
       parameter (MPI_UNDEFINED=-32766)
       parameter (MPI_CART=1)
       parameter (MPI_GRAPH=2)
       parameter (MPI_KEYVAL_INVALID=-1)
       parameter (MPI_STATUS_SIZE=7)
       parameter (MPI_SOURCE=1)
       parameter (MPI_TAG=2)
       parameter (MPI_ERROR=3)
       parameter (MPI_TAG_UB=0)
       parameter (MPI_HOST=1)
       parameter (MPI_IO=2)
       parameter (MPI_WTIME_IS_GLOBAL=3)
       parameter (MPI_NULL_COPY_FN=0)
       parameter (MPI_NULL_DELETE_FN=0)
       parameter (MPI_BSEND_OVERHEAD=40)
C
C global variables
C
        common/lamblk/MPI_BOTTOM
        integer MPI_BOTTOM
C
C NULL "handles" (indices)
C
       integer MPI_GROUP_NULL, MPI_COMM_NULL, MPI_DATATYPE_NULL
       integer MPI_REQUEST_NULL, MPI_OP_NULL, MPI_ERRHANDLER_NULL

       parameter (MPI_GROUP_NULL=-1)
       parameter (MPI_COMM_NULL=-1)
       parameter (MPI_DATATYPE_NULL=-1)
       parameter (MPI_REQUEST_NULL=-1)
       parameter (MPI_OP_NULL=-1)
       parameter (MPI_ERRHANDLER_NULL=-1)
C
C error classes
C
       integer MPI_ERR_BUFFER, MPI_ERR_COUNT, MPI_ERR_TYPE
       integer MPI_ERR_TAG, MPI_ERR_COMM, MPI_ERR_RANK
       integer MPI_ERR_REQUEST, MPI_ERR_ROOT, MPI_ERR_GROUP
       integer MPI_ERR_OP, MPI_ERR_TOPOLOGY, MPI_ERR_DIMS
       integer MPI_ERR_ARG, MPI_ERR_UNKNOWN, MPI_ERR_TRUNCATE
       integer MPI_ERR_OTHER, MPI_ERR_INTERN, MPI_ERR_IN_STATUS
       integer MPI_ERR_PENDING, MPI_ERR_SYSRESOURCE
       integer MPI_ERR_LASTCODE

       parameter (MPI_ERR_BUFFER=1)
       parameter (MPI_ERR_COUNT=2)
       parameter (MPI_ERR_TYPE=3)
       parameter (MPI_ERR_TAG=4)
       parameter (MPI_ERR_COMM=5)
       parameter (MPI_ERR_RANK=6)
       parameter (MPI_ERR_REQUEST=7)
       parameter (MPI_ERR_ROOT=8)
       parameter (MPI_ERR_GROUP=9)
       parameter (MPI_ERR_OP=10)
       parameter (MPI_ERR_TOPOLOGY=11)
       parameter (MPI_ERR_DIMS=12)
       parameter (MPI_ERR_ARG=13)
       parameter (MPI_ERR_UNKNOWN=14)
       parameter (MPI_ERR_TRUNCATE=15)
       parameter (MPI_ERR_OTHER=16)
       parameter (MPI_ERR_INTERN=17)
       parameter (MPI_ERR_IN_STATUS=18)
       parameter (MPI_ERR_PENDING=19)
       parameter (MPI_ERR_SYSRESOURCE=20)
       parameter (MPI_ERR_LASTCODE=21)
C
C comparison results
C
       integer MPI_IDENT, MPI_CONGRUENT, MPI_SIMILAR, MPI_UNEQUAL

       parameter (MPI_IDENT=1)
       parameter (MPI_CONGRUENT=2)
       parameter (MPI_SIMILAR=3)
       parameter (MPI_UNEQUAL=4)
C
C lookup table indices
C
       integer MPI_COMM_WORLD, MPI_COMM_SELF, MPI_GROUP_EMPTY
       integer MPI_ERRORS_ARE_FATAL, MPI_ERRORS_RETURN

       parameter (MPI_COMM_WORLD=0)
       parameter (MPI_COMM_SELF=1)
       parameter (MPI_GROUP_EMPTY=2)
       parameter (MPI_ERRORS_ARE_FATAL=3)
       parameter (MPI_ERRORS_RETURN=4)

       integer MPI_INTEGER, MPI_REAL, MPI_DOUBLE_PRECISION
       integer MPI_COMPLEX, MPI_LOGICAL, MPI_CHARACTER
       integer MPI_BYTE, MPI_PACKED, MPI_UB, MPI_LB, MPI_2REAL
       integer MPI_2DOUBLE_PRECISION, MPI_2INTEGER

       parameter (MPI_INTEGER=5)
       parameter (MPI_REAL=6)
       parameter (MPI_DOUBLE_PRECISION=7)
       parameter (MPI_COMPLEX=8)
       parameter (MPI_LOGICAL=9)
       parameter (MPI_CHARACTER=10)
       parameter (MPI_BYTE=11)
       parameter (MPI_PACKED=11)
       parameter (MPI_UB=12)
       parameter (MPI_LB=13)
       parameter (MPI_2REAL=14)
       parameter (MPI_2DOUBLE_PRECISION=15)
       parameter (MPI_2INTEGER=16)

       integer MPI_MAX, MPI_MIN, MPI_SUM, MPI_PROD, MPI_LAND
       integer MPI_BAND, MPI_LOR, MPI_BOR, MPI_LXOR, MPI_BXOR
       integer MPI_MAXLOC, MPI_MINLOC

       parameter (MPI_MAX=17)
       parameter (MPI_MIN=18)
       parameter (MPI_SUM=19)
       parameter (MPI_PROD=20)
       parameter (MPI_LAND=21)
       parameter (MPI_BAND=22)
       parameter (MPI_LOR=23)
       parameter (MPI_BOR=24)
       parameter (MPI_LXOR=25)
       parameter (MPI_BXOR=26)
       parameter (MPI_MAXLOC=27)
       parameter (MPI_MINLOC=28)
C
C double precision functions
C
       double precision MPI_WTIME, MPI_WTICK
       external MPI_WTIME, MPI_WTICK
