/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	GDB/RBD
 *
 *	$Log:	portable.h,v $
 * Revision 6.0  96/02/29  13:54:02  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.2  96/02/18  01:16:19  gdburns
 * Remove atexit() macro.  Use _lam_atexit().
 * 
 * Revision 5.2.1.1  95/11/23  09:03:04  gdburns
 * Add signed keyword for compilers that want to
 * make char unsigned.
 * 
 * Revision 5.2  94/08/22  14:00:42  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.3  94/08/19  16:00:08  raja
 * Add SCO support.
 * 
 * Revision 5.1.1.2  94/08/19  01:22:21  raja
 * Only SUN4_OS needs the atexit() macro.
 * 
 * Revision 5.1.1.1  94/08/18  11:04:57  vaigl-j
 * Add HP-UX support.
 * 
 * Revision 5.1  94/05/18  12:44:34  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:49:03  gdburns
 * Ohio Release
 * 
 *	Function:	- Put some order into a world of chaos.
 *			- Anybody without an 8 bit byte can get lost.
 */

#ifndef _PORTABLE
#define _PORTABLE

/*
 * To const or not to const.
 */
#ifndef CONST
#if __STDC__ || defined(c_plusplus) || defined(__cplusplus)
#define CONST const
#else
#define CONST
#endif
#endif

/*
 * Can you believe that some compilers would default char to unsigned char?
 */
#ifndef SIGNED
#if __STDC__ || defined(c_plusplus) || defined(__cplusplus)
#define SIGNED signed
#else
#define SIGNED
#endif
#endif

/*
 * Path name separator.
 */
#ifndef DOS
#define STRDIR		'/'
#define STRSDIR		"/"
#else
#define STRDIR		'\\'
#define STRSDIR		"\\"
#endif

#if tputer

typedef int		int4;	/* four bytes */
typedef unsigned int	uint4;
typedef short		int2;	/* two bytes */
typedef unsigned short	uint2;
typedef float		float4;	/* four bytes */
typedef double		float8;	/* eight bytes */
#define stoi4		stoi
#define atoi4		atoi

#else
#if SUN4_OS || SUN4_SOL || sparc

typedef int		int4;
typedef unsigned int	uint4;
typedef short		int2;
typedef unsigned short	uint2;
typedef float		float4;
typedef double		float8;
#define stoi4		stoi
#define atoi4		atoi

#else
#if RS6K || _IBMR2

typedef int		int4;
typedef unsigned int	uint4;
typedef short		int2;
typedef unsigned short	uint2;
typedef float		float4;
typedef double		float8;
#define stoi4		stoi
#define atoi4		atoi

#else
#if SGI || mips

typedef int		int4;
typedef unsigned int	uint4;
typedef short		int2;
typedef unsigned short	uint2;
typedef float		float4;
typedef double		float8;
#define stoi4		stoi
#define atoi4		atoi

#else
#if DECAXP || __alpha

typedef int		int4;
typedef unsigned int	uint4;
typedef short		int2;
typedef unsigned short	uint2;
typedef float		float4;
typedef double		float8;
#define stoi4		stoi
#define atoi4		atoi

#else
#if HPUX || hpux

typedef int		int4;
typedef unsigned int	uint4;
typedef short		int2;
typedef unsigned short	uint2;
typedef float		float4;
typedef double		float8;
#define stoi4		stoi
#define atoi4		atoi

#else
#if i386 || i860 || SCO

typedef int		int4;
typedef unsigned int	uint4;
typedef short		int2;
typedef unsigned short	uint2;
typedef float		float4;
typedef double		float8;
#define stoi4		stoi
#define atoi4		atoi

#else
#if DOS

typedef long		int4;
typedef unsigned long	uint4;
typedef int		int2;
typedef unsigned int	uint2;
typedef float		float4;
typedef double		float8;
#define stoi4		stol
#define atoi4		atol

#else
#if CRAY

typedef short		int4;
typedef unsigned short	uint4;
typedef float		float8;
#define stoi4		stos
#define atoi4		atos

#else

"Machine architecture not defined.  Use hcc(1) instead."

#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif

#define INT4_NIL	((int4) 0)
#define INT4_MAX	((int4) 0x7FFFFFFF)
#define INT4_MIN	((int4) 0x80000000)
#define INT4_LSB	((int4) 0xFF)		/* least significant byte */
#define INT4_LSN	((int4) 0x0F)		/* least significant nibble */
#define INT4_MSN	((int4) 0xF0)		/* most significant nibble */
#define	INT4_SIGN	((int4) 0x80000000)	/* sign bit of an int4 */

#define UINT4_MAX	((uint4) 0xFFFFFFFF)	/* maximum uint4 */

#endif
