/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD/GDB
 *
 *	$Log:	t_types.h,v $
 * Revision 6.0  96/02/29  13:54:05  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  14:00:45  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.2  94/08/19  16:00:14  raja
 * Add SCO support.
 * 
 * Revision 5.1.1.1  94/08/18  11:04:37  vaigl-j
 * Add HP-UX support.
 * 
 * Revision 5.1  94/05/18  12:44:40  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:49:07  gdburns
 * Ohio Release
 * 
 * Revision 2.2.1.5  94/02/19  16:31:28  raja
 * Add compiler-dependent macros as a safety guard.
 * Force a parsing error when no system macros defined.
 * 
 * Revision 2.2.1.4  94/02/16  14:39:11  raja
 * Change the default byte ordering.
 * Add SUN4_SOL.
 * 
 * Revision 2.2.1.3  94/01/07  21:05:29  raja
 * Change to compiler-independent system macros.
 * 
 * Revision 2.2.1.2  93/09/15  14:31:46  raja
 * Declare ANSI C and C++ function prototypes.
 * 
 * Revision 2.2.1.1  93/05/04  15:13:58  raja
 * new CPUs, new functions
 * 
 * Revision 2.2  92/04/30  14:46:24  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.4  92/04/27  17:28:59  raja
 * ttolcpy() and ltotcpy() macros call the rwcpy() function.  Much cleaner.
 * 
 * Revision 2.1.1.3  91/11/27  15:28:15  raja
 * Added integer array byte ordering.
 * 
 * Revision 2.1.1.2  91/11/11  23:57:50  gdburns
 * Don't forget Mr. Cray.
 * 
 * Revision 2.1.1.1  91/11/01  17:46:36  gdburns
 * Correct cpp bug and include i860 and 386i.
 * 
 * Revision 2.1  91/03/20  11:35:11  gdburns
 * Ohio Release
 * 
 *	Function:	- defines type conversions
 */

#ifndef _T_TYPES
#define _T_TYPES

#include <portable.h>

/*
 * machine/CPU types
 */
#if tputer

#define ltot(x)		rw(x)
#define ttol(x)		rw(x)

#define ltoti2(x, y)	revn(x, y, 2)
#define ttoli2(x, y)	revn(x, y, 2)
#define ltoti4(x, y)	rev4(x, y)
#define ttoli4(x, y)	rev4(x, y)
#define ltotf4(x, y)	rev4(x, y)
#define ttolf4(x, y)	rev4(x, y)
#define ltotf8(x, y)	rev8(x, y)
#define ttolf8(x, y)	rev8(x, y)

#define mltoti2(x, l)	mrevn(x, 2, l)
#define mttoli2(x, l)	mrevn(x, 2, l)
#define mltoti4(x, l)	mrev4(x, l)
#define mttoli4(x, l)	mrev4(x, l)
#define mltotf4(x, l)	mrev4(x, l)
#define mttolf4(x, l)	mrev4(x, l)
#define mltotf8(x, l)	mrev8(x, l)
#define mttolf8(x, l)	mrev8(x, l)

#else
#if SUN4_OS || SUN4_SOL || sparc

#define ltot(x)		(x)
#define ttol(x)		(x)

#define ltoti2(x, y)	*((uint2 *) (y)) = *((uint2 *) (x))
#define ttoli2(x, y)	*((uint2 *) (y)) = *((uint2 *) (x))
#define ltoti4(x, y)	*((uint4 *) (y)) = *((uint4 *) (x))
#define ttoli4(x, y)	*((uint4 *) (y)) = *((uint4 *) (x))
#define ltotf4(x, y)	*((float4 *) (y)) = *((float4 *) (x))
#define ttolf4(x, y)	*((float4 *) (y)) = *((float4 *) (x))
#define ltotf8(x, y)	*((float8 *) (y)) = *((float8 *) (x))
#define ttolf8(x, y)	*((float8 *) (y)) = *((float8 *) (x))

#define mltoti2(x, l)
#define mttoli2(x, l)
#define mltoti4(x, l)
#define mttoli4(x, l)
#define mltotf4(x, l)
#define mttolf4(x, l)
#define mltotf8(x, l)
#define mttolf8(x, l)

#else
#if RS6K || _IBMR2

#define ltot(x)		(x)
#define ttol(x)		(x)

#define ltoti2(x, y)	*((uint2 *) (y)) = *((uint2 *) (x))
#define ttoli2(x, y)	*((uint2 *) (y)) = *((uint2 *) (x))
#define ltoti4(x, y)	*((uint4 *) (y)) = *((uint4 *) (x))
#define ttoli4(x, y)	*((uint4 *) (y)) = *((uint4 *) (x))
#define ltotf4(x, y)	*((float4 *) (y)) = *((float4 *) (x))
#define ttolf4(x, y)	*((float4 *) (y)) = *((float4 *) (x))
#define ltotf8(x, y)	*((float8 *) (y)) = *((float8 *) (x))
#define ttolf8(x, y)	*((float8 *) (y)) = *((float8 *) (x))

#define mltoti2(x, l)
#define mttoli2(x, l)
#define mltoti4(x, l)
#define mttoli4(x, l)
#define mltotf4(x, l)
#define mttolf4(x, l)
#define mltotf8(x, l)
#define mttolf8(x, l)

#else
#if SGI || mips

#define ltot(x)		(x)
#define ttol(x)		(x)

#define ltoti2(x, y)	*((uint2 *) (y)) = *((uint2 *) (x))
#define ttoli2(x, y)	*((uint2 *) (y)) = *((uint2 *) (x))
#define ltoti4(x, y)	*((uint4 *) (y)) = *((uint4 *) (x))
#define ttoli4(x, y)	*((uint4 *) (y)) = *((uint4 *) (x))
#define ltotf4(x, y)	*((float4 *) (y)) = *((float4 *) (x))
#define ttolf4(x, y)	*((float4 *) (y)) = *((float4 *) (x))
#define ltotf8(x, y)	*((float8 *) (y)) = *((float8 *) (x))
#define ttolf8(x, y)	*((float8 *) (y)) = *((float8 *) (x))

#define mltoti2(x, l)
#define mttoli2(x, l)
#define mltoti4(x, l)
#define mttoli4(x, l)
#define mltotf4(x, l)
#define mttolf4(x, l)
#define mltotf8(x, l)
#define mttolf8(x, l)

#else
#if HPUX || hpux

#define ltot(x)		(x)
#define ttol(x)		(x)

#define ltoti2(x, y)	*((uint2 *) (y)) = *((uint2 *) (x))
#define ttoli2(x, y)	*((uint2 *) (y)) = *((uint2 *) (x))
#define ltoti4(x, y)	*((uint4 *) (y)) = *((uint4 *) (x))
#define ttoli4(x, y)	*((uint4 *) (y)) = *((uint4 *) (x))
#define ltotf4(x, y)	*((float4 *) (y)) = *((float4 *) (x))
#define ttolf4(x, y)	*((float4 *) (y)) = *((float4 *) (x))
#define ltotf8(x, y)	*((float8 *) (y)) = *((float8 *) (x))
#define ttolf8(x, y)	*((float8 *) (y)) = *((float8 *) (x))

#define mltoti2(x, l)
#define mttoli2(x, l)
#define mltoti4(x, l)
#define mttoli4(x, l)
#define mltotf4(x, l)
#define mttolf4(x, l)
#define mltotf8(x, l)
#define mttolf8(x, l)

#else
#if i386 || i860 || SCO

#define ltot(x)		rw(x)
#define ttol(x)		rw(x)

#define ltoti2(x, y)	revn(x, y, 2)
#define ttoli2(x, y)	revn(x, y, 2)
#define ltoti4(x, y)	rev4(x, y)
#define ttoli4(x, y)	rev4(x, y)
#define ltotf4(x, y)	rev4(x, y)
#define ttolf4(x, y)	rev4(x, y)
#define ltotf8(x, y)	rev8(x, y)
#define ttolf8(x, y)	rev8(x, y)

#define mltoti2(x, l)	mrevn(x, 2, l)
#define mttoli2(x, l)	mrevn(x, 2, l)
#define mltoti4(x, l)	mrev4(x, l)
#define mttoli4(x, l)	mrev4(x, l)
#define mltotf4(x, l)	mrev4(x, l)
#define mttolf4(x, l)	mrev4(x, l)
#define mltotf8(x, l)	mrev8(x, l)
#define mttolf8(x, l)	mrev8(x, l)

#else
#if DOS

#define ltot(x)		rw(x)
#define ttol(x)		rw(x)

#define ltoti2(x, y)	revn(x, y, 2)
#define ttoli2(x, y)	revn(x, y, 2)
#define ltoti4(x, y)	rev4(x, y)
#define ttoli4(x, y)	rev4(x, y)
#define ltotf4(x, y)	rev4(x, y)
#define ttolf4(x, y)	rev4(x, y)
#define ltotf8(x, y)	rev8(x, y)
#define ttolf8(x, y)	rev8(x, y)

#define mltoti2(x, l)	mrevn(x, 2, l)
#define mttoli2(x, l)	mrevn(x, 2, l)
#define mltoti4(x, l)	mrev4(x, l)
#define mttoli4(x, l)	mrev4(x, l)
#define mltotf4(x, l)	mrev4(x, l)
#define mttolf4(x, l)	mrev4(x, l)
#define mltotf8(x, l)	mrev8(x, l)
#define mttolf8(x, l)	mrev8(x, l)

#else
#if CRAY

#define ltot(x)		rw(x)
#define ttol(x)		rw(x)

#define ltoti4(x, y)	rev4(x, y)
#define ttoli4(x, y)	rev4(x, y)
#define ltotf8(x, y)	ltoieeef(x, y)
#define ttolf8(x, y)	ieeetolf(x, y)
 
#define mltoti4(x, l)	mrev4(x, l)
#define mttoli4(x, l)	mrev4(x, l)
#define mltotf8(x, l)	mltoieeef(x, l)
#define mttolf8(x, l)	mieeetolf(x, l)

#else
#if DECAXP || __alpha

#define ltot(x)		rw(x)
#define ttol(x)		rw(x)

#define ltoti2(x, y)	revn(x, y, 2)
#define ttoli2(x, y)	revn(x, y, 2)
#define ltoti4(x, y)	rev4(x, y)
#define ttoli4(x, y)	rev4(x, y)
#define ltotf4(x, y)	rev4(x, y)
#define ttolf4(x, y)	rev4(x, y)
#define ltotf8(x, y)	rev8(x, y)
#define ttolf8(x, y)	rev8(x, y)

#define mltoti2(x, l)	mrevn(x, 2, l)
#define mttoli2(x, l)	mrevn(x, 2, l)
#define mltoti4(x, l)	mrev4(x, l)
#define mttoli4(x, l)	mrev4(x, l)
#define mltotf4(x, l)	mrev4(x, l)
#define mttolf4(x, l)	mrev4(x, l)
#define mltotf8(x, l)	mrev8(x, l)
#define mttolf8(x, l)	mrev8(x, l)

#else

"Machine architecture not defined.  Use hcc(1) instead."

#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif

/*
 * generic "reverse word" non-IEEE chip template
 */
/*
#define ltot(x)		rw(x)
#define ttol(x)		rw(x)

#define ltoti2(x, y)	revn(x, y, 2)
#define ttoli2(x, y)	revn(x, y, 2)
#define ltoti4(x, y)	rev4(x, y)
#define ttoli4(x, y)	rev4(x, y)
#define ltotf4(x, y)	ltoieeef(x, y)
#define ttolf4(x, y)	ieeetolf(x, y)
#define ltotf8(x, y)	ltoieeed(x, y)
#define ttolf8(x, y)	ieeetold(x, y)

#define mltoti2(x, l)	mrevn(x, 2, l)
#define mttoli2(x, l)	mrevn(x, 2, l)
#define mltoti4(x, l)	mrev4(x, l)
#define mttoli4(x, l)	mrev4(x, l)
#define mltotf4(x, l)	mltoieeef(x, l)
#define mttolf4(x, l)	mieeetolf(x, l)
#define mltotf8(x, l)	mltoieeed(x, l)
#define mttolf8(x, l)	ieeetold(x, l);
*/

/*
 * prototypes
 */
#ifndef __ARGS
#if __STDC__ || defined(c_plusplus) || defined(__cplusplus)
#define __ARGS(a)	a
#else
#define __ARGS(a)	()
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern uint4		rw __ARGS((uint4 oword));
extern void		rev4 __ARGS((void *src, void *dest));
extern void		rev8 __ARGS((void *src, void *dest));
extern void		revn __ARGS((void *src, void *dest, int size));
extern void		mrev4 __ARGS((void *array, int num));
extern void		mrev8 __ARGS((void *array, int num));
extern void		mrevn __ARGS((void *array, int size, int num));
extern void		ltoieeef __ARGS((float *src, void *dest));
extern void		ltoieeed __ARGS((double *src, void *dest));
extern void		ieeetolf __ARGS((void *src, float *dest));
extern void		ieeetold __ARGS((void *src, double *dest));
extern void		mltoieeef __ARGS((float *array, int num));
extern void		mltoieeed __ARGS((double *array, int num));
extern void		mieeetolf __ARGS((float *array, int num));
extern void		mieeetold __ARGS((double *array, int num));

#ifdef __cplusplus
}
#endif

#endif /* _T_TYPES */
