/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	GDB/RBD
 *
 *	$Log:	terror.h,v $
 * Revision 6.0  96/02/29  13:54:06  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.2  96/02/06  20:44:04  gdburns
 * Add EBADHOST.
 * 
 * Revision 5.2.1.1  96/01/18  20:41:40  gdburns
 * error code changes
 * 
 * Revision 5.2  94/08/22  14:00:46  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:44:41  gdburns
 * Ohio Release
 * 
 * Revision 2.3.1.1  94/05/18  10:50:48  raja
 * Add terrorstr(), EMPIINIT, EMPINOINIT.
 * 
 * Revision 2.3  94/04/22  12:49:08  gdburns
 * Ohio Release
 * 
 *	Function:	- Trollius error codes
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 */

#ifndef _TERROR
#define _TERROR

#define ELOW			201
#define EUNKNOWN		201
#define EDEADNODE		202
#define ENOEXDESCRIPTORS	203
#define EFULL			204
#define ENOTPROCESS		205
#define EBADREQUEST		206
#define ENOTMALLOCED		207
#define EGERFLOW		208
#define ESERVICE		209
#define EMAGIC			210
#define EBLOWN			211
#define EIMPOSSIBLE		212
#define EI860PROC		213
#define EBADHOST		214
#define ENOKERNEL		215
#define ENOTATTACHED		216
#define EMSGLEN			218
#define EEOF			219
#define ECOLLIDE		220

#define ESHARE			223
#define EBADLINK		224
#define EACK			225

#define	EUSAGE			226
#define EOPTION			227
#define	EBADNODE		229
#define	EBADIDSPEC		230
#define ENONODES		231

#define ENORDESCRIPTORS		232
#define ENOBFDESCRIPTORS	233
#define ENOBTDESCRIPTORS	234
#define ENOFLDESCRIPTORS	235
#define ENOPDESCRIPTORS		236
#define ENOKDESCRIPTORS		237
#define EBADMOSESREQ		238
#define EBADTAG			240
#define EDELETE			241
#define ENOBOOTSTRAP		242
#define EBADREC			243
#define EBADASCIINUMB		244
#define EHIGHWATER		245
#define EINGROUP		246
#define EGMAXPROC		247
#define EGSINGLETON		248
#define EGNOTPROC		249
#define EBADGROUP		250
#define EMPIINIT		251
#define EMPINOINIT		252

#define EHIGH			252

#ifndef EINTR
#define EINTR			4
#endif

#ifndef ENOMEM
#define ENOMEM			12
#endif

#ifndef EINVAL
#define EINVAL			22
#endif

#ifndef EWOULDBLOCK
#define EWOULDBLOCK		35
#endif

#ifndef ENAMETOOLONG
#define ENAMETOOLONG		63
#endif

/*
 * prototypes
 */
#ifndef __ARGS
#if __STDC__ || defined(c_plusplus) || defined(__cplusplus)
#define __ARGS(a)	a
#else
#define __ARGS(a)	()
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern char		*terrorstr __ARGS((const char *msg));
extern void		terror __ARGS((const char *msg));

#ifdef __cplusplus
}
#endif

extern int		errno;

#endif /* _TERROR */
