/*
 *      Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *      GDB/RBD
 *
 *      $Log:	trreq.h,v $
 * Revision 6.0  96/02/29  13:54:06  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  01:39:28  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:00:48  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:44:43  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:49:09  gdburns
 * Ohio Release
 * 
 *	Function:	- constants and templates associated with traced
 */

#ifndef _TRREQ
#define _TRREQ

#include <all_list.h>
#include <portable.h>

/*
 * traced requests
 */
#define	TRQSTORE	0		/* store traces */
#define	TRQGET		1		/* get traces */
#define	TRQFORGET	2		/* get and remove traces */
#define	TRQSWEEP	3		/* remove all traces */
#define	TRQUDIE		4		/* remove pid related traces */
#define	TRQWIPE		5		/* reset traced */
#define	TRQMAX		6		/* # requests */

/*
 * misc constants
 */
#define TRSMAX		100		/* # state descs in trstate */
#define TRHASHSIZE	100		/* initial size, trace hash tbl */ 
#define TRMAXSPACE	0x200000	/* total trace space limit */
#define TRANYLIST	-1		/* matches any trace list */
#define TRANYPID	-1		/* matches any pid */
#define TRDEFFNAME	"def.lamtr"	/* default trace output file */

/*
 * traced request
 */
struct trreq {
	int4		trq_src_node;	/* client's nodeid */
	int4		trq_src_event;	/* client's reply event	*/
	int4		trq_req;	/* traced request code */
	int4		trq_pid;	/* client pid */
	int4		trq_length;	/* trace length */
	int4		trq_lnum;	/* list number */
};

/*
 * traced reply
 */
struct trreply {
	int4		trr_errno;	/* error code */
	int4		trr_length;	/* length of selected trace data */
};

/*
 * trace buffer
 */
struct trbuffer {
	int4		trb_length;	/* buffer length */
	int4		trb_pid;	/* buffer pid */
	char		*trb_buffer;	/* buffer ptr */
};

/*
 * trace list
 */
struct trblist {
	int4		trl_lnum;	/* list number */
	LIST		*trl_ld;	/* list descriptor */
};

/*
 * prototypes
 */
#ifndef __ARGS
#if __STDC__ || defined(c_plusplus) || defined(__cplusplus)
#define __ARGS(a)	a
#else
#define __ARGS(a)	()
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern int		lam_rtrstore __ARGS((int4 node, int4 lnum, int4 pid,
					const char *bf, int4 len));
extern int		lam_rtrget __ARGS((int4 node, int4 lnum,
					int4 pid, char **buffer));
extern int		lam_rtrforget __ARGS((int4 node, int4 lnum,
					int4 pid, char **buffer));
extern int		lam_rtrfget __ARGS((int4 node, int4 lnum,
					int4 pid, int fd));
extern int		lam_rtrfforget __ARGS((int4 node, int4 lnum,
					int4 pid, int fd));
extern int		lam_rtrsweep __ARGS((int4 node, int4 lnum));
extern int		lam_rtrudie __ARGS((int4 node, int4 pid));
extern int		lam_rtrwipe __ARGS((int4 node));

#ifdef __cplusplus
}
#endif

#endif
