/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD
 *
 *	$Log:	address.c,v $
 * Revision 6.0  96/02/29  14:11:50  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.2  96/02/18  21:17:37  gdburns
 * major overhaul
 * 
 * Revision 5.2.1.1  95/06/29  02:09:32  raja
 * MPI_BOTTOM is now (void *).
 * 
 * Revision 5.2  94/08/22  14:03:43  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:09  gdburns
 * Ohio Release
 * 
 *	Function:	- return address of location
 *	Accepts:	- location
 *			- ptr to address (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Address(loc, paddr)

void			*loc;
MPI_Aint		*paddr;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIADDRESS);

	if (paddr == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIADDRESS, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	*paddr = ((MPI_Aint) loc) - ((MPI_Aint) MPI_BOTTOM);

	__lam_resetfunc_(BLKMPIADDRESS);
	return(MPI_SUCCESS);
}
