/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	attrget.c,v $
 * Revision 6.0  96/02/29  14:11:56  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.2  96/02/18  21:17:58  gdburns
 * major overhaul
 * 
 * Revision 5.2.1.1  95/03/17  14:25:20  raja
 * Change (void **) to (void *) value.
 * 
 * Revision 5.2  94/08/22  14:03:47  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:14  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:47:59  gdburns
 * new for 5.1
 * 
 *	Function:	- get attribute value
 *	Accepts:	- communicator
 *			- attribute key
 *			- ptr attribute value (returned value)
 *			- ptr found flag (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

/*
 * external functions
 */
extern struct _attrkey	*__lam_getattr_();
extern struct _attr	*__lam_getkey_();

int
MPI_Attr_get(comm, key, value, found)

MPI_Comm		comm;
int			key;
void			*value;
int			*found;

{
	struct _attr	*p;

	__lam_initerr_();
	__lam_setfunc_(BLKMPIATTRGET);
/*
 * Check the arguments.
 */
	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIATTRGET, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if ((value == 0) || (found == 0)) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIATTRGET, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	if (__lam_getattr_(key) == 0) {
		return(__lam_errfunc_(comm,
			BLKMPIATTRGET, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
/*
 * Check if the key is attached to the communicator.
 */
	p = __lam_getkey_(comm, key);
	if (p == 0) {
		*found = 0;
	} else {
		*found = 1;
		*((void **) value) = p->a_value;
	}

	__lam_resetfunc_(BLKMPIATTRGET);
	return(MPI_SUCCESS);
}
