/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD
 *
 *	$Log:	bsendinit.c,v $
 * Revision 6.0.1.1  96/04/28  19:10:27  nevin
 * Fake requests status must be set as it is never started
 * 
 * Revision 6.0  96/02/29  14:12:02  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:18:33  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:03:51  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:18  gdburns
 * Ohio Release
 * 
 *	Function:	- create a buffered send request
 *	Accepts:	- buffer
 *			- count
 *			- datatype
 *			- destination
 *			- tag
 *			- communicator
 *			- request (returned)
 *	Returns: 	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

/*
 * external functions
 */
extern int		__lam_errfunc_();
extern void		__lam_initerr_();
extern void		__lam_resetfunc_();
extern void		__lam_setfunc_();
extern int		_mpi_req_build();


int
MPI_Bsend_init(buf, count, dtype, dest, tag, comm, req)

void			*buf;
int			count;
MPI_Datatype		dtype;
int			dest;
int			tag;
MPI_Comm		comm;
MPI_Request		*req;

{
	int		err;			/* error code */

	__lam_initerr_();
	__lam_setfunc_(BLKMPIBSINIT);
/*
 * Create the fake user request.
 */
	*req = MPI_REQUEST_NULL;
	err = _mpi_req_build(buf, count, dtype, dest, tag, comm,
				LAM_RQIFAKE, req);

	if (err != MPI_SUCCESS) {
		return(__lam_errfunc_(comm, BLKMPIBSINIT, err));
	}

	(*req)->rq_marks |= LAM_RQFPERSIST;
	(*req)->rq_status.MPI_ERROR = MPI_SUCCESS;
	(*req)->rq_status.MPI_SOURCE = MPI_PROC_NULL;

	__lam_resetfunc_(BLKMPIBSINIT);
	return(MPI_SUCCESS);
}
