/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD
 *
 *	$Log:	bufattach.c,v $
 * Revision 6.0  96/02/29  14:12:02  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:18:36  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:03:51  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:19  gdburns
 * Ohio Release
 * 
 *	Function:	- attach buffer to process
 *	Accepts:	- buffer address
 *			- buffer size
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Buffer_attach(buf, size)

void			*buf;
int			size;

{
	int		err;			/* error code */

	__lam_initerr_();
	__lam_setfunc_(BLKMPIBUFATTACH);

	err = __lam_bufattach_(buf, size);
	if (err != MPI_SUCCESS) {
		return(__lam_errfunc_(MPI_COMM_WORLD, BLKMPIBUFATTACH, err));
	}

	__lam_resetfunc_(BLKMPIBUFATTACH);
	return(MPI_SUCCESS);
}
