/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD
 *
 *	$Log:	bufdetach.c,v $
 * Revision 6.0  96/02/29  14:12:03  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:18:39  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:03:52  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:20  gdburns
 * Ohio Release
 * 
 *	Function:	- detach buffer from process
 *	Accepts:	- ptr buffer address
 *			- ptr buffer size
 *	Returns:	- MPI_SUCCESS
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Buffer_detach(pbuf, psize)

void			*pbuf;
int			*psize;

{
	int		err;			/* error code */

	__lam_initerr_();
	__lam_setfunc_(BLKMPIBUFDETACH);

	err = __lam_bufdetach_(pbuf, psize);
	if (err != MPI_SUCCESS) {
		return(__lam_errfunc_(MPI_COMM_WORLD, BLKMPIBUFDETACH, err));
	}

	__lam_resetfunc_(BLKMPIBUFDETACH);
	return(MPI_SUCCESS);
}
