/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	cartdimget.c,v $
 * Revision 6.0  96/02/29  14:12:07  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:20:11  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:03:55  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:23  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:04  gdburns
 * new for 5.1
 * 
 *	Function:	- get # dimensions in cartesian topology
 *	Accepts:	- communicator
 *			- ptr # dimensions (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Cartdim_get(comm, pndims)

MPI_Comm		comm;
int			*pndims;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPICARTDIMGET);
/*
 * Check the arguments.
 */
	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPICARTDIMGET, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (comm->c_inter) {
		return(__lam_errfunc_(comm,
			BLKMPICARTDIMGET, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (comm->c_topo_type != MPI_CART) {
		return(__lam_errfunc_(comm, BLKMPICARTDIMGET,
				__lam_mkerr_(MPI_ERR_TOPOLOGY, 0)));
	}

	if (pndims == 0) {
		return(__lam_errfunc_(comm,
			BLKMPICARTDIMGET, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	*pndims = comm->c_topo_ndims;

	__lam_resetfunc_(BLKMPICARTDIMGET);
	return(MPI_SUCCESS);
}
