/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	cgroup.c,v $
 * Revision 6.0  96/02/29  14:12:15  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:20:37  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:02  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:32  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:08  gdburns
 * new for 5.1
 * 
 *	Function:	- get communicator group (create a new group)
 *	Accepts:	- communicator
 *			- ptr to group
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Comm_group(comm, pgroup)

MPI_Comm		comm;
MPI_Group		*pgroup;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPICOMMGROUP);

	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPICOMMGROUP, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (pgroup == 0) {
		return(__lam_errfunc_(comm,
			BLKMPICOMMGROUP, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	*pgroup = comm->c_group;
	++(comm->c_group->g_refcount);

	__lam_resetfunc_(BLKMPICOMMGROUP);
  	return(MPI_SUCCESS);
}
