/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	crank.c,v $
 * Revision 6.0  96/02/29  14:12:16  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:20:39  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:03  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:33  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:08  gdburns
 * new for 5.1
 * 
 *	Function:	- get caller's rank in communicator
 *	Accepts:	- communicator
 *			- ptr rank
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Comm_rank(comm, prank)

MPI_Comm		comm;
int			*prank;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPICOMMRANK);

	if ((comm != MPI_COMM_NULL) && (prank != 0)) {
		*prank = comm->c_group->g_myrank;
	}
	else if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPICOMMRANK, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}
	else {
		return(__lam_errfunc_(comm,
			BLKMPICOMMRANK, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	__lam_resetfunc_(BLKMPICOMMRANK);
	return(MPI_SUCCESS);
}
