/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	crsize.c,v $
 * Revision 6.0  96/02/29  14:12:17  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:20:42  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:04  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:35  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:09  gdburns
 * new for 5.1
 * 
 *	Function:	- return the size of the remote group
 *	Accepts:	- inter-communicator
 *			- ptr to size (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Comm_remote_size(comm, psize)

MPI_Comm		comm;
int			*psize;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPICOMMRSIZE);

	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPICOMMRSIZE, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (comm->c_inter == 0) {
		return(__lam_errfunc_(comm,
			BLKMPICOMMRSIZE, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (psize == 0) {
		return(__lam_errfunc_(comm,
			BLKMPICOMMRSIZE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	*psize = comm->c_rgroup->g_nprocs;

	__lam_resetfunc_(BLKMPICOMMRSIZE);
	return(MPI_SUCCESS);
}
