/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	csize.c,v $
 * Revision 6.0  96/02/29  14:12:18  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:20:44  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:05  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:36  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:10  gdburns
 * new for 5.1
 * 
 *	Function:	- return the size of the communicator's group
 *	Accepts:	- communicator
 *			- ptr to size (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Comm_size(comm, psize)

MPI_Comm		comm;
int			*psize;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPICOMMSIZE);

	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPICOMMSIZE, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (psize == 0) {
		return(__lam_errfunc_(comm,
			BLKMPICOMMSIZE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	*psize = comm->c_group->g_nprocs;

	__lam_resetfunc_(BLKMPICOMMSIZE);
	return(MPI_SUCCESS);
}
