/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	ctestinter.c,v $
 * Revision 6.0  96/02/29  14:12:20  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:21:12  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:06  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:38  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:10  gdburns
 * new for 5.1
 * 
 *	Function:	- check if inter-communicator
 *	Accepts:	- communicator
 *			- ptr to flag
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Comm_test_inter(comm, pflag)

MPI_Comm		comm;
int			*pflag;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPICOMMTESTINTER);

	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPICOMMTESTINTER, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (pflag == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPICOMMTESTINTER, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	*pflag = comm->c_inter;

	__lam_resetfunc_(BLKMPICOMMTESTINTER);
	return(MPI_SUCCESS);
}
