/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	errclass.c,v $
 * Revision 6.0  96/02/29  14:12:22  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:22:11  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:10  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:40  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:12  gdburns
 * new for 5.1
 * 
 *	Function:	- get error class of error code
 *	Accepts:	- error code
 *			- ptr error class (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Error_class(errcode, class)

int			errcode;
int			*class;

{
	int		func;
	int		error;

	__lam_initerr_();
	__lam_setfunc_(BLKMPIERRCLASS);
/*
 * Check the arguments.
 */
	if (class == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIERRCLASS, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	__lam_bkerr_(errcode, class, &func, &error);

	__lam_resetfunc_(BLKMPIERRCLASS);
	return(MPI_SUCCESS);
}
