/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	errcreate.c,v $
 * Revision 6.0  96/02/29  14:12:23  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:22:14  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:11  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:41  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:12  gdburns
 * new for 5.1
 * 
 *	Function:	- create error handler
 *	Accepts:	- error function
 *			- ptr error handler (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <stdlib.h>

#include <blktype.h>
#include <mpi.h>
#include <terror.h>

int
MPI_Errhandler_create(errfunc, errhdl)

MPI_Handler_function 	*errfunc;
MPI_Errhandler		*errhdl;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIERRCREATE);
/*
 * Check the arguments.
 */
	if ((errfunc == 0) || (errhdl == 0)) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIERRCREATE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
/*
 * Create the handler.
 */
	*errhdl = (MPI_Errhandler) malloc((unsigned) sizeof(struct _errhdl));
	if (*errhdl == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIERRCREATE, __lam_mkerr_(MPI_ERR_OTHER, errno)));
	}

	(*errhdl)->eh_func = (void (*)()) errfunc;
	(*errhdl)->eh_f77hdl = -1;
	(*errhdl)->eh_refcount = 1;

	__lam_resetfunc_(BLKMPIERRCREATE);
	return(MPI_SUCCESS);
}
