/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	errfree.c,v $
 * Revision 6.0  96/02/29  14:12:23  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:22:15  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:11  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:42  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:12  gdburns
 * new for 5.1
 * 
 *	Function:	- free error handler
 *	Accepts:	- ptr error handler
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <stdlib.h>

#include <blktype.h>
#include <mpi.h>

int
MPI_Errhandler_free(errhdl)

MPI_Errhandler		*errhdl;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIERRFREE);
/*
 * Check the arguments.
 */
	if (errhdl == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIERRFREE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	if (*errhdl == MPI_ERRHANDLER_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIERRFREE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
/*
 * Free the handler.
 */
	if (--((*errhdl)->eh_refcount) == 0) {
		free((char *) *errhdl);
	}

	*errhdl = MPI_ERRHANDLER_NULL;

	__lam_resetfunc_(BLKMPIERRFREE);
	return(MPI_SUCCESS);
}
