/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	errget.c,v $
 * Revision 6.0  96/02/29  14:12:24  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:22:16  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:12  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:43  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:13  gdburns
 * new for 5.1
 * 
 *	Function:	- get error handler of communicator
 *	Accepts:	- communicator
 *			- ptr to error handler
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Errhandler_get(comm, errhdl)

MPI_Comm		comm;
MPI_Errhandler		*errhdl;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIERRGET);
/*
 * Check the arguments.
 */
	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIERRGET, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (errhdl == 0) {
		return(__lam_errfunc_(comm,
			BLKMPIERRGET, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
/*
 * Get the communicator's error handler.
 */
	*errhdl = comm->c_errhdl;

	__lam_resetfunc_(BLKMPIERRGET);
	return(MPI_SUCCESS);
}
