/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	errset.c,v $
 * Revision 6.0  96/02/29  14:12:25  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.2  96/02/18  21:22:18  gdburns
 * major overhaul
 * 
 * Revision 5.2.1.1  94/09/26  14:29:21  raja
 * Increment handler ref. count.
 * 
 * Revision 5.2  94/08/22  14:04:12  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:43  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:13  gdburns
 * new for 5.1
 * 
 *	Function:	- set error handler for communicator
 *	Accepts:	- communicator
 *			- error handler
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Errhandler_set(comm, errhdl)

MPI_Comm		comm;
MPI_Errhandler		errhdl;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIERRSET);
/*
 * Check the arguments.
 */
	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIERRSET, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (errhdl == MPI_ERRHANDLER_NULL) {
		return(__lam_errfunc_(comm,
			BLKMPIERRSET, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
/*
 * Set the communicator's error handler.
 */
	comm->c_errhdl = errhdl;
	++(errhdl->eh_refcount);

	__lam_resetfunc_(BLKMPIERRSET);
	return(MPI_SUCCESS);
}
