/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	getprocname.c,v $
 * Revision 6.0  96/02/29  14:12:33  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:22:34  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:18  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:49  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:16  gdburns
 * new for 5.1
 * 
 *	Function:	- get the host name
 *	Accepts:	- name buffer (returned value)
 *			- ptr name length (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <string.h>

#include <blktype.h>
#include <mpi.h>
#include <terror.h>

int
MPI_Get_processor_name(name, len)

char			*name;
int			*len;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIGETPNAME);

	if (gethostname(name, MPI_MAX_PROCESSOR_NAME - 1)) {
		return(__lam_errfunc_(MPI_COMM_WORLD, BLKMPIGETPNAME,
				__lam_mkerr_(MPI_ERR_OTHER, errno)));
	} else {
		name[MPI_MAX_PROCESSOR_NAME - 1] = '\0';
		*len = strlen(name);
	}

	__lam_resetfunc_(BLKMPIGETPNAME);
	return(MPI_SUCCESS);
}
