/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	gfree.c,v $
 * Revision 6.0  96/02/29  14:12:35  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:22:37  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:20  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:51  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:17  gdburns
 * new for 5.1
 * 
 *	Function:	- free a group
 *	Accepts:	- ptr to group
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <stdlib.h>

#include <blktype.h>
#include <mpi.h>

int
MPI_Group_free(pg)

MPI_Group		*pg;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIGROUPFREE);

	if (pg == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIGROUPFREE, __lam_mkerr_(MPI_ERR_GROUP, 0)));
	}
	else if (*pg) {
		if ((--(*pg)->g_refcount) == 0) {
			free((char *) *pg);
		}

		*pg = MPI_GROUP_NULL;
	}

	__lam_resetfunc_(BLKMPIGROUPFREE);
	return(MPI_SUCCESS);
}
