/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	grank.c,v $
 * Revision 6.0  96/02/29  14:12:38  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:22:41  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:22  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:50:53  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:18  gdburns
 * new for 5.1
 * 
 *	Function:	- get caller's rank in group
 *	Accepts:	- group
 *			- ptr rank
 *	Returns:	- 0 or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Group_rank(group, prank)

MPI_Group		group;
int			*prank;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIGROUPRANK);

	if ((group != MPI_GROUP_NULL) && (prank != 0)) {
		*prank = group->g_myrank;
	}
	else if (group == MPI_GROUP_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIGROUPRANK, __lam_mkerr_(MPI_ERR_GROUP, 0)));
	}
	else {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIGROUPRANK, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	__lam_resetfunc_(BLKMPIGROUPRANK);
	return(MPI_SUCCESS);
}
