/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	gsize.c,v $
 * Revision 6.0  96/02/29  14:12:45  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:22:51  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:28  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:00  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:23  gdburns
 * new for 5.1
 * 
 *	Function:	- return the size of the group
 *	Accepts:	- group
 *			- ptr to size (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Group_size(group, psize)

MPI_Group		group;
int			*psize;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIGROUPSIZE);

	if ((group != MPI_GROUP_NULL) && (psize != 0)) {
		*psize = group->g_nprocs;
	}
	else if (group == MPI_GROUP_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIGROUPSIZE, __lam_mkerr_(MPI_ERR_GROUP, 0)));
	}
	else {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIGROUPSIZE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	__lam_resetfunc_(BLKMPIGROUPSIZE);
	return(MPI_SUCCESS);
}
