/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	keycreate.c,v $
 * Revision 6.0  96/02/29  14:12:58  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:23:34  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:37  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:12  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:29  gdburns
 * new for 5.1
 * 
 *	Function:	- create an attribute key
 *	Accepts:	- copy function
 *			- delete function
 *			- ptr key value
 *			- extra state info
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <terror.h>

/*
 * external functions
 */
extern struct _attrkey	*__lam_getattr_();

int
MPI_Keyval_create(cpyfunc, delfunc, pkey, extra)

int			(*cpyfunc)();
int			(*delfunc)();
int			*pkey;
void			*extra;

{
	int		key;
	struct _attrkey	*p;

	__lam_initerr_();
	__lam_setfunc_(BLKMPIKEYCREATE);
/*
 * Check the arguments.
 */
	if (pkey == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIKEYCREATE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
/*
 * Create the key.
 */
	if ((key = __lam_mkkey_()) < 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIKEYCREATE, __lam_mkerr_(MPI_ERR_OTHER, errno)));
	}

	*pkey = key;
	p = __lam_getattr_(key);
	if (p == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIKEYCREATE, __lam_mkerr_(MPI_ERR_OTHER, errno)));
	}
/*
 * Fill the attribute information.
 */
	p->ak_copy = cpyfunc;
	p->ak_del = delfunc;
	p->ak_extra = extra;
	p->ak_refcount = 1;
	p->ak_f77comm = -1;

	__lam_resetfunc_(BLKMPIKEYCREATE);
	return(MPI_SUCCESS);
}
