/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	keyfree.c,v $
 * Revision 6.0  96/02/29  14:12:58  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:23:35  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:37  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:13  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:30  gdburns
 * new for 5.1
 * 
 *	Function:	- free attribute key
 *	Accepts:	- ptr key value
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <terror.h>

/*
 * external functions
 */
extern struct _attrkey	*__lam_getattr_();

int
MPI_Keyval_free(pkey)

int			*pkey;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIKEYFREE);
/*
 * Check the arguments.
 */
	if (pkey == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIKEYFREE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
/*
 * Free the key, if it is valid.
 */
	if (__lam_freekey_(*pkey)) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIKEYFREE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	*pkey = MPI_KEYVAL_INVALID;

	__lam_resetfunc_(BLKMPIKEYFREE);
	return(MPI_SUCCESS);
}
