/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD
 *
 *	$Log:	lamcid.c,v $
 * Revision 6.0  96/02/29  14:13:00  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.3  96/02/18  21:23:38  gdburns
 * major overhaul
 * 
 * Revision 5.2.1.2  95/08/21  18:18:12  raja
 * Move shared functions to mpietc.c.
 * 
 * Revision 5.2.1.1  95/03/30  15:32:45  raja
 * Don't reuse context IDs.
 * 
 * Revision 5.2  94/08/22  14:04:39  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:15  gdburns
 * Ohio Release
 * 
 *	Function:	- manage context identifiers
 *			- trivial version
 */

#include <typical.h>
#include <mpi.h>

/*
 * static variables
 */
static int		topcid = 0;		/* top unused context ID */

/*
 *	__lam_getcid_
 *
 *	Function:	- get next available context ID
 *	Returns:	- context ID or LAMERROR
 */
int
__lam_getcid_()

{
	return( ((topcid < 0) || (topcid > MPI_MAX_CID)) ? LAMERROR : topcid);
}

/*
 *	__lam_setcid_
 *
 *	Function:	- set highest used context ID
 *	Accepts:	- context ID
 */
void
__lam_setcid_(cid)

int			cid;

{
	topcid = cid + 1;
}

/*
 *	__lam_rmcid_
 *
 *	Function:	- deallocate (remove) a context ID
 *	Accepts:	- context ID
 */
void
__lam_rmcid_(cid)

int			cid;

{
}

/*
 *	__lam_nukecids_
 *
 *	Function:	- deallocate all context IDs (cleanup)
 */
void
__lam_nukecids_()

{
	topcid = 0;
}
