/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	NJN
 *
 *	$Log:	lamfault.c,v $
 * Revision 6.0  96/02/29  14:13:04  gdburns
 * Ohio Release
 * 
 *	Function:	- LAM-MPI fault tolerance
 */

#include <all_list.h>
#include <mpi.h>

/*
 *	__lam_commfault_
 *
 *	Function:	- invalidate communicators involving a dead node
 *	Accepts:	- dead node's nodeid
 */
void
__lam_commfault_(node)

int			node;

{
	MPI_Comm	*comm;			/* communicator */
	struct _proc	**p;
	int		i;
	
	comm = al_top(__lam_comms_);

	for ( ; comm; comm = al_next(__lam_comms_, comm)) {
/*
 * There is nothing to do if the local group is already dead.
 */
		if ((*comm)->c_status & LAM_CLDEAD) continue;
/*
 * Check the local group.
 */
		p = (*comm)->c_group->g_procs;
		
		for (i = (*comm)->c_group->g_nprocs; i > 0 ; i--, p++) {

			if ((*p)->p_gps.gps_node == node) {
				(*comm)->c_status |= LAM_CLDEAD;
				break;
			}
		}
/*
 * If it's an intercommunicator and the remote group is not dead, then
 * check the remote group.
 */
		if ((*comm)->c_inter && ! ((*comm)->c_status & LAM_CRDEAD)) {
			
			p = (*comm)->c_rgroup->g_procs;
		
			for (i = (*comm)->c_rgroup->g_nprocs; i > 0 ;
					i--, p++) {

				if ((*p)->p_gps.gps_node == node) {
					(*comm)->c_status |= LAM_CRDEAD;
					break;
				}
			}
		}
	}
}
