/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	laminited.c,v $
 * Revision 6.0  96/02/29  14:13:04  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:24:06  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:42  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:18  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:32  gdburns
 * new for 5.1
 * 
 *	Function:	- test if MPI has been initialized
 */

#include <stdio.h>
#include <unistd.h>

#include <mpi.h>
#include <terror.h>

/*
 *	__lam_inited_
 *
 *	Function:	- check if MPI has been initialized
 *	Returns:	- TRUE or FALSE
 */
int
__lam_inited_()

{
	return(_kio.ki_pid == getpid());
}

/*
 *	__lam_initerr_
 *
 *	Function:	- if MPI not initialized, abort as an error
 */
void
__lam_initerr_()

{
	if (__lam_inited_() == 0) {
		errno = EMPINOINIT;
		fprintf(stderr, "MPI error: process not initialized\n");
		exit(errno);
	}
}
