/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	GDB
 *
 *	$Log:	mpil_signal.c,v $
 * Revision 6.0  96/02/29  14:13:19  gdburns
 * Ohio Release
 * 
 *	Function:	- delivers a signal to a process
 *	Accepts:	- communicator
 *			- process rank
 *			- signal number
 */

#include <blktype.h>
#include <lam_ksignal.h>
#include <mpi.h>
#include <portable.h>
#include <preq.h>
#include <terror.h>

int
MPIL_Signal(comm, rank, signo)

MPI_Comm		comm;
int			rank;
int			signo;

{
	int		err;		/* MPI error code */
	int		nid;		/* process's node ID */
	int		pid;		/* process ID */

	__lam_initerr_();
	__lam_setfunc_(BLKMPILSIGNAL);

	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			__lam_getfunc_(), __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if ((rank == MPI_ANY_SOURCE) || (rank < 0) ||
			(rank >= comm->c_group->g_nprocs)) {
		return(__lam_errfunc_(comm,
			__lam_getfunc_(), __lam_mkerr_(MPI_ERR_RANK, 0)));
	}

	err = MPIL_Comm_gps(comm, rank, &nid, &pid);

	if (err != MPI_SUCCESS) {
		return(__lam_errfunc_(comm, BLKMPILSIGNAL, err));
	}

	if (rpdoom((int4) nid, (int4) SELECT_PID, (int4) pid, (int4) signo)) {
		return(__lam_errfunc_(comm, BLKMPILSIGNAL, errno));
	}

	__lam_resetfunc_(BLKMPILSIGNAL);
	return(MPI_SUCCESS);
}
