/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	opcreate.c,v $
 * Revision 6.0  96/02/29  14:13:21  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:24:53  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:51  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:28  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:37  gdburns
 * new for 5.1
 * 
 *	Function:	- create a reduction operator
 *	Accepts:	- function
 *			- commutative flag
 *			- ptr operator
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <stdlib.h>

#include <blktype.h>
#include <mpi.h>
#include <terror.h>

int
MPI_Op_create(func, commute, pop)

void			(*func)();
int			commute;
MPI_Op			*pop;

{
	int		class;
	MPI_Op		op;

	__lam_initerr_();
	__lam_setfunc_(BLKMPIOPCREATE);

	if ((pop == 0) || (func == 0)) {
		class = (pop == 0) ? MPI_ERR_OP : MPI_ERR_ARG;
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIOPCREATE, __lam_mkerr_(class, 0)));
	}

	op = (MPI_Op) malloc(sizeof(struct _op));
	if (op == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIOPCREATE, __lam_mkerr_(MPI_ERR_OTHER, errno)));
	}

	*pop = op;
	op->op_func = func;
	op->op_commute = commute;
	op->op_f77dtype = -1;

	__lam_resetfunc_(BLKMPIOPCREATE);
	return(MPI_SUCCESS);
}
