/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	opfree.c,v $
 * Revision 6.0  96/02/29  14:13:22  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:25:00  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:52  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:29  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:37  gdburns
 * new for 5.1
 * 
 *	Function:	- free a reduction operator
 *	Accepts:	- ptr operator
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <stdlib.h>

#include <blktype.h>
#include <mpi.h>

int
MPI_Op_free(pop)

MPI_Op			*pop;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIOPFREE);

	if (pop == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIOPFREE, __lam_mkerr_(MPI_ERR_OP, 0)));
	}

	if (*pop) {
		free((char *) *pop);
		*pop = MPI_OP_NULL;
	}

	__lam_resetfunc_(BLKMPIOPFREE);
	return(MPI_SUCCESS);
}
