/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	packsize.c,v $
 * Revision 6.0  96/02/29  14:13:23  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:25:04  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:53  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:30  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:38  gdburns
 * new for 5.1
 * 
 *	Function:	- get size needed to pack data
 *	Accepts:	- count
 *			- datatype
 *			- communicator
 *			- ptr to size
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Pack_size(count, dtype, comm, psize)

int			count;
MPI_Datatype		dtype;
MPI_Comm		comm;
int			*psize;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPIPACKSIZE);
/*
 * Check the arguments.
 */
	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPIPACKSIZE, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (count < 0) {
		return(__lam_errfunc_(comm,
			BLKMPIPACKSIZE, __lam_mkerr_(MPI_ERR_COUNT, 0)));
	}

	if (dtype == MPI_DATATYPE_NULL) {
		return(__lam_errfunc_(comm,
			BLKMPIPACKSIZE, __lam_mkerr_(MPI_ERR_TYPE, 0)));
	}

	if (psize == 0) {
		return(__lam_errfunc_(comm,
			BLKMPIPACKSIZE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
/*
 * Return the size.
 */
	*psize = count * dtype->dt_size;

	__lam_resetfunc_(BLKMPIPACKSIZE);
	return(MPI_SUCCESS);
}
