/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD
 *
 *	$Log:	recvinit.c,v $
 * Revision 6.0  96/02/29  14:13:26  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:25:15  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:04:56  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:36  gdburns
 * Ohio Release
 * 
 *	Function:	- create a receive request
 *	Accepts:	- buffer
 *			- count
 *			- datatype
 *			- source
 *			- tag
 *			- communicator
 *			- request (returned)
 *	Returns: 	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

/*
 * external functions
 */
extern int		__lam_errfunc_();
extern void		__lam_initerr_();
extern void		__lam_resetfunc_();
extern void		__lam_setfunc_();
extern int		_mpi_req_build();


int
MPI_Recv_init(buf, count, dtype, src, tag, comm, req)

void			*buf;
int			count;
MPI_Datatype		dtype;
int			src;
int			tag;
MPI_Comm		comm;
MPI_Request		*req;

{
	int		err;			/* error code */

	__lam_initerr_();
	__lam_setfunc_(BLKMPIRINIT);

	*req = MPI_REQUEST_NULL;
	err = _mpi_req_build(buf, count, dtype, src, tag, comm,
				LAM_RQIRECV, req);

	if (err != MPI_SUCCESS) return(__lam_errfunc_(comm, BLKMPIRINIT, err));

	(*req)->rq_marks |= LAM_RQFPERSIST;

	__lam_resetfunc_(BLKMPIRINIT);
	return(MPI_SUCCESS);
}
