/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD/GDB
 *
 *	$Log:	send.c,v $
 * Revision 6.0  96/02/29  14:13:35  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:25:52  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:05:02  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:45  gdburns
 * Ohio Release
 * 
 *	Function:	- send a message in standard mode
 *	Accepts:	- buffer
 *			- count
 *			- datatype
 *			- destination
 *			- tag
 *			- communicator
 *	Returns: 	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

/*
 * external functions
 */
extern void		__lam_initerr_();
extern void		__lam_resetfunc_();
extern void		__lam_setfunc_();
extern int		__lam_send_();

int
MPI_Send(buf, count, dtype, dest, tag, comm)

void			*buf;
int			count;
MPI_Datatype		dtype;
int			dest;
int			tag;
MPI_Comm		comm;

{
	int		err;

	__lam_initerr_();
	__lam_setfunc_(BLKMPISEND);

	err = __lam_send_(buf, count, dtype, dest, tag, comm, LAM_RQISEND);

	__lam_resetfunc_(BLKMPISEND);

	if (err != MPI_SUCCESS) return(__lam_errfunc_(comm, BLKMPISEND, err));

	return(MPI_SUCCESS);
}
