/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD/GDB
 *
 *	$Log:	ssend.c,v $
 * Revision 6.0  96/02/29  14:13:38  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:25:57  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:05:04  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:48  gdburns
 * Ohio Release
 * 
 *	Function:	- synchronous send
 *	Accepts:	- buffer
 *			- count
 *			- datatype
 *			- destination
 *			- tag
 *			- communicator
 *	Returns: 	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Ssend(buf, count, dtype, dest, tag, comm)

void			*buf;
int			count;
MPI_Datatype		dtype;
int			dest;
int			tag;
MPI_Comm		comm;

{
	int		err;

	__lam_initerr_();
	__lam_setfunc_(BLKMPISSEND);

	err = __lam_send_(buf, count, dtype, dest, tag, comm, LAM_RQISSEND);

	__lam_resetfunc_(BLKMPISSEND);

	if (err != MPI_SUCCESS) return(__lam_errfunc_(comm, BLKMPISSEND, err));

	return(MPI_SUCCESS);
}
