/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD
 *
 *	$Log:	start.c,v $
 * Revision 6.0  96/02/29  14:13:40  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:26:00  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:05:06  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:49  gdburns
 * Ohio Release
 * 
 *	Function:	- start communication request
 *	Accepts:	- ptr to request
 *	Returns: 	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

/*
 * external functions
 */
extern int		__lam_errfunc_();
extern void		__lam_initerr_();
extern void		__lam_resetfunc_();
extern void		__lam_setfunc_();


int
MPI_Start(req)

MPI_Request		*req;

{
	int		err;			/* error code */

	__lam_initerr_();
	__lam_setfunc_(BLKMPISTART);

	if (req == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPISTART, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	if (*req == MPI_REQUEST_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPISTART, __lam_mkerr_(MPI_ERR_REQUEST, 0)));
	}

	err = MPI_Startall(1, req);
	if (err != MPI_SUCCESS) {
		return(__lam_errfunc_((*req)->rq_comm, BLKMPISTART, err));
	}

	__lam_resetfunc_(BLKMPISTART);
	return(MPI_SUCCESS);
}
