/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD
 *
 *	$Log:	tcommit.c,v $
 * Revision 6.0  96/02/29  14:13:43  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:26:02  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:05:07  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:51  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:48  gdburns
 * new for 5.1
 * 
 *	Function:	- commit a datatype
 *	Accepts:	- ptr to datatype
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>
#include <terror.h>

/*
 * external functions
 */
extern int		__lam_trdtype_();

int
MPI_Type_commit(dtype)

MPI_Datatype		*dtype;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPITCOMMIT);

	if (dtype == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITCOMMIT, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
	else if (*dtype == MPI_DATATYPE_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITCOMMIT, __lam_mkerr_(MPI_ERR_TYPE, 0)));
	}
	else {
		if (__lam_trdtype_(*dtype)) {
			return(__lam_errfunc_(MPI_COMM_WORLD, BLKMPITCOMMIT,
					__lam_mkerr_(MPI_ERR_INTERN, errno)));
		}

		(*dtype)->dt_commit = 1;
	}

	__lam_resetfunc_(BLKMPITCOMMIT);
	return(MPI_SUCCESS);
}
