/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	RBD
 *
 *	$Log:	test.c,v $
 * Revision 6.0  96/02/29  14:13:46  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:26:05  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:05:09  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:51:53  gdburns
 * Ohio Release
 * 
 *	Function:	- test if request is done
 *	Accepts:	- request
 *			- flag (returned)
 *			- status (returned)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

/*
 * external functions
 */
extern void		__lam_initerr_();
extern void		__lam_resetfunc_();
extern void		__lam_setfunc_();
extern int		__lam_errfunc_();
extern int		__lam_test_();


int
MPI_Test(req, flag, stat)

MPI_Request		*req;
int			*flag;
MPI_Status		*stat;

{
	int		err;
	MPI_Comm	comm;
	
	__lam_initerr_();
	__lam_setfunc_(BLKMPITEST);

	comm = (req) ? (*req)->rq_comm : MPI_COMM_WORLD;
	
	err = __lam_test_(req, 1, flag, stat);

	__lam_resetfunc_(BLKMPITEST);

	if (err != MPI_SUCCESS) {
		return(__lam_errfunc_(comm, BLKMPITEST, err));
	}

	return(MPI_SUCCESS);
}
