/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	testcancel.c,v $
 * Revision 6.0  96/02/29  14:13:49  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:26:09  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:05:11  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/08/18  12:01:24  raja
 * new for 5.2
 * 
 *	Function:	- test if cancellation succeeded
 *	Accepts:	- ptr status structure
 *			- ptr flag (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Test_cancelled(pstat, pflag)

MPI_Status		*pstat;
int			*pflag;

{
	__lam_setfunc_(BLKMPITESTCANCEL);

	if ((pstat == 0) || (pflag == 0)) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITESTCANCEL, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	*pflag = (pstat->MPI_SOURCE == MPI_CANCEL_SOURCE) ? 1 : 0;

	__lam_resetfunc_(BLKMPITESTCANCEL);
	return(MPI_SUCCESS);
}
