/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	textent.c,v $
 * Revision 6.0  96/02/29  14:13:50  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:26:13  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:05:12  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.1  94/08/02  15:35:55  raja
 * Use MPI_Aint instead of int.
 * 
 * Revision 5.1  94/05/18  12:51:56  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:50  gdburns
 * new for 5.1
 * 
 *	Function:	- return extent of datatype
 *	Accepts:	- datatype
 *			- ptr to extent (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Type_extent(dtype, pextent)

MPI_Datatype		dtype;
MPI_Aint		*pextent;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPITEXTENT);

	if (dtype == MPI_DATATYPE_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITEXTENT, __lam_mkerr_(MPI_ERR_TYPE, 0)));
	}
	else if (pextent == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITEXTENT, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
	else {
		*pextent = dtype->dt_upper - dtype->dt_lower;
	}

	__lam_resetfunc_(BLKMPITEXTENT);
	return(MPI_SUCCESS);
}
