/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	tlb.c,v $
 * Revision 6.0  96/02/29  14:13:54  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:26:20  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:05:17  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.1  94/08/02  15:36:49  raja
 * Use MPI_Aint instead of int.
 * 
 * Revision 5.1  94/05/18  12:52:00  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:52  gdburns
 * new for 5.1
 * 
 *	Function:	- return lower bound of datatype
 *	Accepts:	- datatype
 *			- ptr to lower bound (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Type_lb(dtype, plb)

MPI_Datatype		dtype;
MPI_Aint		*plb;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPITLB);

	if (dtype == MPI_DATATYPE_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITLB, __lam_mkerr_(MPI_ERR_TYPE, 0)));
	}
	else if (plb == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITLB, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
	else {
		*plb = dtype->dt_lower;
	}

	__lam_resetfunc_(BLKMPITLB);
	return(MPI_SUCCESS);
}
