/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	topotest.c,v $
 * Revision 6.0  96/02/29  14:13:55  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:26:22  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:05:18  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:52:01  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:53  gdburns
 * new for 5.1
 * 
 *	Function:	- get topology assigned to communicator
 *	Accepts:	- communicator
 *			- ptr topology type
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Topo_test(comm, ptopo)

MPI_Comm		comm;
int			*ptopo;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPITOPOTEST);
/*
 * Check the arguments.
 */
	if (comm == MPI_COMM_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITOPOTEST, __lam_mkerr_(MPI_ERR_COMM, 0)));
	}

	if (ptopo == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITOPOTEST, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}

	*ptopo = comm->c_topo_type;

	__lam_resetfunc_(BLKMPITOPOTEST);
	return(MPI_SUCCESS);
}
