/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	tsize.c,v $
 * Revision 6.0  96/02/29  14:13:55  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.2  96/02/18  21:26:25  gdburns
 * major overhaul
 * 
 * Revision 5.2.1.1  95/09/28  11:08:36  gdburns
 * MPI 1.0 and 1.1 say that size is an int.
 * 
 * Revision 5.2  94/08/22  14:05:18  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.1  94/08/02  15:36:46  raja
 * Use MPI_Aint instead of int.
 * 
 * Revision 5.1  94/05/18  12:52:02  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:53  gdburns
 * new for 5.1
 * 
 *	Function:	- return size of datatype
 *	Accepts:	- datatype
 *			- ptr to size (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Type_size(dtype, psize)

MPI_Datatype		dtype;
int			*psize;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPITSIZE);

	if (dtype == MPI_DATATYPE_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITSIZE, __lam_mkerr_(MPI_ERR_TYPE, 0)));
	}
	else if (psize == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITSIZE, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
	else {
		*psize = dtype->dt_size;
	}

	__lam_resetfunc_(BLKMPITSIZE);
	return(MPI_SUCCESS);
}
