/*
 *	Ohio Trollius
 *	Copyright 1994 The Ohio State University
 *	RBD
 *
 *	$Log:	tub.c,v $
 * Revision 6.0  96/02/29  14:13:57  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.1  96/02/18  21:26:29  gdburns
 * major overhaul
 * 
 * Revision 5.2  94/08/22  14:05:20  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.1  94/08/02  15:36:48  raja
 * Use MPI_Aint instead of int.
 * 
 * Revision 5.1  94/05/18  12:52:03  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/05/18  12:48:54  gdburns
 * new for 5.1
 * 
 *	Function:	- return upper bound of datatype
 *	Accepts:	- datatype
 *			- ptr to upper bound (returned value)
 *	Returns:	- MPI_SUCCESS or error code
 */

#include <blktype.h>
#include <mpi.h>

int
MPI_Type_ub(dtype, pub)

MPI_Datatype		dtype;
MPI_Aint		*pub;

{
	__lam_initerr_();
	__lam_setfunc_(BLKMPITUB);

	if (dtype == MPI_DATATYPE_NULL) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITUB, __lam_mkerr_(MPI_ERR_TYPE, 0)));
	}
	else if (pub == 0) {
		return(__lam_errfunc_(MPI_COMM_WORLD,
			BLKMPITUB, __lam_mkerr_(MPI_ERR_ARG, 0)));
	}
	else {
		*pub = dtype->dt_upper;
	}

	__lam_resetfunc_(BLKMPITUB);
	return(MPI_SUCCESS);
}
