/*
 *	Ohio Trollius
 *      Copyright 1995 The Ohio State University
 *      GDB/RBD
 *
 *	$Log:	TRIL.c,v $
 * Revision 6.0  96/02/29  14:04:19  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.2  96/02/16  01:55:20  gdburns
 * Use name macros for HPUX.
 * Use new rploadgo() binding.
 * 
 * Revision 5.2.1.1  95/09/12  14:00:34  raja
 * Put macros for RS6K.
 * 
 * Revision 5.2  94/08/22  14:10:28  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:57:42  gdburns
 * Ohio Release
 * 
 *	Function:	- f2c F77 interface for libtrillium functions
 */

#include <stdlib.h>

#include <portable.h>
#include <preq.h>
#include <terror.h>

/*
 * external functions
 */
extern char		*f2cstring();

/*
 * RS6K, HPUX F77/C interface
 */
#if RS6K || HPUX
#define rpwt_		rpwt
#define rpldgo_		rpldgo
#endif	/* RS6K */

/*
 * simple wrappers
 */
void rpwt_(n, p, s, ie) int4 *n, *p, *s, *ie;
		{ *ie = rpwait(n, p, s) ? errno : 0; }

/*
 * thicker wrappers
 */
void
rpldgo_(srcnode, destnode, filename, flags, pid, idx, ierror, lstr)

int4			*srcnode;
int4			*destnode;
char			*filename;
int4			*flags;
int4			*pid;
int4			*idx;
int4			*ierror;
unsigned int		lstr;

{
	char		*cstr;
	int		r;

	if ((cstr = f2cstring(filename, lstr)) == 0) {
		*ierror = errno;
		return;
	}

	r = rploadgo(*srcnode, *destnode, cstr, *flags, (char **) 0, pid, idx);
	*ierror = r ? errno : 0;

	free(cstr);
}
