/*
 *	Ohio Trollius
 *	Copyright 1993 The Ohio State University
 *	GDB
 *
 *	$Log:	rpwait.c,v $
 * Revision 6.0  96/02/29  14:05:07  gdburns
 * Ohio Release
 * 
 * Revision 5.2  94/08/22  14:13:38  gdburns
 * Ohio Release
 * 
 * Revision 5.1  94/05/18  12:58:16  gdburns
 * Ohio Release
 * 
 * Revision 2.3  94/04/22  12:46:23  gdburns
 * Ohio Release
 * 
 * Revision 2.2.1.2  93/10/13  17:17:38  gdburns
 * Move ksigblock() before nsend() due to new kernel.
 * 
 * Revision 2.2.1.1  92/09/07  23:11:41  gdburns
 * facelift due to LAM
 * 
 * Revision 2.2  92/04/30  14:53:29  trillium
 * Ohio Release
 * 
 * Revision 2.1.1.2  92/03/05  19:59:55  gdburns
 * Kludge source event so as not to clash with rloadgo().
 * 
 * Revision 2.1.1.1  91/06/05  13:28:57  gdburns
 * Use unmodified parent reply event (-pid).
 * 
 * Revision 2.1  91/03/20  11:38:49  gdburns
 * Ohio Release
 * 
 *	Function:	- waits for kenya process to die
 *			- based on Trollius 2.0 Copyright 1990
 *			  The Ohio State University and Cornell
 *			  Research Foundation
 *
 *	Accepts:	- ptr to node ID
 *			- ptr to process ID
 *			- ptr to child process status
 *
 *	Returns:	- 0 or ERROR with errno set accordingly
 */

#include <net.h>
#include <portable.h>
#include <preq.h>
#include <t_types.h>
#include <typical.h>

int
rpwait(nodeid, pid, status)

int4			*nodeid;
int			*pid;
int			*status;

{
	struct nmsg	nhead;		/* network message descriptor */
	struct preply	reply;		/* kenyad reply */

	nhead.nh_event = (-getpid()) & 0xBFFFFFFF;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = sizeof(struct preply);
	nhead.nh_msg = (char *) &reply;

	if (nrecv(&nhead)) {
		return(ERROR);
	}

	*nodeid = ttol(reply.pr_nodeid);
	*pid = (int) ttol(reply.pr_pid);
	*status = (int) ttol(reply.pr_reply);

	return(0);
}
