/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	GDB/RBD
 *
 *	$Log:	hcc.c,v $
 * Revision 6.0  96/02/29  14:18:39  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.3  96/02/24  11:09:16  gdburns
 * Remove -lsun for SGI.
 * 
 * Revision 5.2.1.2  95/09/02  13:15:48  gdburns
 * Remove extinct libtools.
 * 
 * Revision 5.2.1.1  95/07/05  18:43:30  raja
 * Support LAMHOME and LAMHCC.
 * Use argvbreak() and argvcount().
 * 
 * Revision 5.2  94/08/22  14:18:23  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.2  94/08/19  16:18:29  raja
 * Add SCO support + fix Jim's typo. :-)
 * 
 * Revision 5.1.1.1  94/08/19  16:09:35  vaigl-j
 * Remove #elif's for HP-UX and gracefully handle '-c'.
 * 
 * Revision 5.1  94/05/18  13:01:16  gdburns
 * Ohio Release
 * 
 *	Function:	- wrapper for C program compilation
 */

#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <errno.h>

#include <args.h>
#include <boot.h>
#include <portable.h>

#ifndef DEFTCC
#define DEFTCC "cc"
#endif

/*
 * external functions
 */
extern int		cnfexec();
extern char		*getenv();

/*
 * local variables
 */
static char		ph[_POSIX_PATH_MAX];
static char		plib[_POSIX_PATH_MAX];


main(argc, argv)

int			argc;
char			*argv[];

{
	int		ac;		/* cc # args */
	int		status;		/* cc return code */
	int4		i;		/* favourite index */
	int4		fl_libs;	/* add libs to command line */
	char		**av;		/* cc arg vector */
	char		*phome;		/* installation dir */
	char		*tcc;		/* cc tool */

	phome = getenv("LAMHOME");
	if (phome == 0) phome = getenv("TROLLIUSHOME");
	if (phome == 0) phome = DEFP;

	if ((strlen(phome) + 32) >= _POSIX_PATH_MAX) {
		fprintf(stderr, "hcc: LAM home pathname too long\n");
		exit(1);
	}
/*
 * Form include directory pathname.
 */
	strcpy(ph, "-I");
	strcat(ph, phome);
	strcat(ph, STRSDIR);
	strcat(ph, "h");
/*
 * Form library directory pathname.
 */
	strcpy(plib, "-L");
	strcat(plib, phome);
	strcat(plib, STRSDIR);
	strcat(plib, "lib");

	tcc = getenv("LAMHCC");
	if (tcc == 0) tcc = getenv("TROLLIUSHCC");
	if (tcc == 0) tcc = DEFTCC;

	av = argvbreak(tcc, ' ');
	if (av == 0) {
		perror("hcc");
		exit(errno);
	}

	ac = argvcount(av);

	argvadd(&ac, &av, plib);

	fl_libs = 1;

	for (i = 1; i < argc; ++i) {
		argvadd(&ac, &av, argv[i]);

		if (strcmp(argv[i], "-c") == 0) fl_libs = 0;
	}

	argvadd(&ac, &av, ph);

	if (fl_libs) {
		argvadd(&ac, &av, "-ltstdio");
		argvadd(&ac, &av, "-ltrillium");
		argvadd(&ac, &av, "-largs");
		argvadd(&ac, &av, "-lt");

#if SUN4_SOL
		argvadd(&ac, &av, "-lsocket");
		argvadd(&ac, &av, "-lnsl");
#else
#if SCO
		argvadd(&ac, &av, "-lsocket");
#endif /* SCO */
#endif /* SUN4_SOL */
	}

	status = cnfexec(av);

	if (status != 0) {
		perror(tcc);
		exit(status);
	}

	return(0);
}
