/*
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	GDB/RBD
 *
 *	$Log:	hf77.c,v $
 * Revision 6.0  96/02/29  14:20:51  gdburns
 * Ohio Release
 * 
 * Revision 5.2.1.3  96/02/24  11:09:44  gdburns
 * Remove -lsun for SGI.
 * 
 * Revision 5.2.1.2  95/09/02  13:16:08  gdburns
 * Remove extinct libtools.
 * 
 * Revision 5.2.1.1  95/07/06  00:07:18  raja
 * Support LAMHOME and LAMHF77.
 * 
 * Revision 5.2  94/08/22  14:18:33  gdburns
 * Ohio Release
 * 
 * Revision 5.1.1.2  94/08/19  16:38:04  raja
 * Add SCO support.
 * 
 * Revision 5.1.1.1  94/08/19  16:35:04  vaigl-j
 * Add HP-UX support and gracefully handle '-c'.
 * 
 * Revision 5.1  94/05/18  13:01:24  gdburns
 * Ohio Release
 * 
 *	Function:	- wrapper for FORTRAN program compilation
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>

#include <args.h>
#include <boot.h>
#include <portable.h>

#ifndef DEFTF77
#if HPUX
#define DEFTF77 "fort77"
#else
#define DEFTF77 "f77"
#endif
#endif

/*
 * external functions
 */
extern int		cnfexec();

/*
 * local variables
 */
static char		plib[_POSIX_PATH_MAX];


main(argc, argv)

int			argc;
char			*argv[];

{
	int		ac;		/* f77 # args */
	int		status;		/* f77 return code */
	int4		fl_libs;	/* add libs to command line */
	int4		i;		/* favourite index */
	char		**av;		/* f77 arg vector */
	char		*phome;		/* installation dir */
	char		*tf77;		/* f77 tool */

	phome = getenv("LAMHOME");
	if (phome == 0) phome = getenv("TROLLIUSHOME");
	if (phome == 0) phome = DEFP;

	if ((strlen(phome) + 32) >= _POSIX_PATH_MAX) {
		fprintf(stderr, "hf77: LAM home pathname too long\n");
		exit(1);
	}
/*
 * Form library directory pathname.
 */
	strcpy(plib, "-L");
	strcat(plib, phome);
	strcat(plib, STRSDIR);
	strcat(plib, "lib");

	tf77 = getenv("LAMHF77");
	if (tf77 == 0) tf77 = getenv("TROLLIUSHF77");
	if (tf77 == 0) tf77 = DEFTF77;

	ac = 0;
	av = 0;
	argvadd(&ac, &av, tf77);

	argvadd(&ac, &av, plib);

	fl_libs = 1;

	for (i = 1; i < argc; ++i) {
		argvadd(&ac, &av, argv[i]);

		if (strcmp(argv[i], "-c") == 0) fl_libs = 0;
	}

	if (fl_libs) {
		argvadd(&ac, &av, "-ltstdio");
		argvadd(&ac, &av, "-ltrillium");
		argvadd(&ac, &av, "-largs");
		argvadd(&ac, &av, "-lt");
#if SUN4_SOL
		argvadd(&ac, &av, "-lsocket");
		argvadd(&ac, &av, "-lnsl");
#else
#if SCO
		argvadd(&ac, &av, "-lsocket");
#endif /* SCO */
#endif /* SUN4_SOL */
	}

	status = cnfexec(av);

	if (status) {
		perror(tf77);
		exit(status);
	}

	exit(0);
}
